declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE EMPLOYMENT_REVIEW_PWDMAN
  (
   ID 								NUMERIC(16) 		NOT NULL,
	EMPLOYMENT_REVIEW 				NUMERIC(16) 		NOT NULL,
	PWDMANAGEMENT 					NUMERIC(16),
	PWDMANAGEMENT_CODE 				VARCHAR(256),
	PWDMANAGEMENT_IS_DEFAULT 		NUMERIC(1),
	PWDMANAGEMENT_DISABLED 			NUMERIC(1) 			DEFAULT 0,
	PWDCFG 							NUMERIC(16),
	PWDCFG_NAME 					VARCHAR(256),
	PWDCFG_DESCRIPTION 				VARCHAR(256),
	PWDCFG_STATE 					NUMERIC(16) 		DEFAULT 0,
	PWDCFG_SYNC 					NUMERIC(1),
	ATTR1 							VARCHAR(256),
	ATTR2 							VARCHAR(256),
	ATTR3 							VARCHAR(256),
	ATTR4 							VARCHAR(256),
	ATTR5 							VARCHAR(256),
	ATTR6 							VARCHAR(256),
	ATTR7 							VARCHAR(256),
	ATTR8 							VARCHAR(256),
	ATTR9 							VARCHAR(256),
	ATTR10 							VARCHAR(256)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN
    ADD CONSTRAINT EMPLOYMENT_REV_PWDMAN_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN TO IGA;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN TO IGACONN;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN TO REP;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN TO AA;


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN
   ADD CONSTRAINT EMP_REV_PWDM_EMP_REV_FK
   FOREIGN KEY (EMPLOYMENT_REVIEW)
   REFERENCES EMPLOYMENT_REVIEW (ID)
   ON DELETE CASCADE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN
   ADD CONSTRAINT EMP_REV_PWDM_PWDCFG_FK
   FOREIGN KEY (PWDCFG)
   REFERENCES PWDCFG (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN
   ADD CONSTRAINT EMP_REV_PWDM_PWDMANAGEMENT_FK
   FOREIGN KEY (PWDMANAGEMENT)
   REFERENCES PWDMANAGEMENT (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX EMP_REV_PWDMAN_EMPREV_IDX ON EMPLOYMENT_REVIEW_PWDMAN
  (EMPLOYMENT_REVIEW)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=
'CREATE SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';	

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMPLOYMENT_REVIEW_PWDMAN' );

GRANT USAGE ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ TO REP;
GRANT SELECT ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ TO AA;
