declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PERSON_REM_REVIEWER
    ADD COLUMN ATTESTATION NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PERSON_REM_REVIEWER
    ADD COLUMN STEP NUMERIC(1)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PERSON_REM_REVIEWER
    ADD COLUMN CERT_ROOT_OWNER NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PERSON_REM_REVIEWER
    ADD COLUMN ESCALATION_OWNER NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PERSON_REM_REVIEWER
   ADD CONSTRAINT PRREV_ATTESTATION_FK
   FOREIGN KEY (ATTESTATION)
   REFERENCES ATTESTATION (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PERSON_REM_REVIEWER
   ADD CONSTRAINT PR_REVIEWER_CRO_FK
   FOREIGN KEY (CERT_ROOT_OWNER)
   REFERENCES PERSON (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PERSON_REM_REVIEWER
   ADD CONSTRAINT PR_REVIEWER_EO_FK
   FOREIGN KEY (ESCALATION_OWNER)
   REFERENCES PERSON (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PRREV_ATTESTATION_FK_IDX ON PERSON_REM_REVIEWER
   (ATTESTATION ASC) ALLOW REVERSE SCANS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PR_REVIEWER_CRO_FK_IDX ON PERSON_REM_REVIEWER
   (CERT_ROOT_OWNER) ALLOW REVERSE SCANS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PR_REVIEWER_EO_FK_IDX ON PERSON_REM_REVIEWER
   (ESCALATION_OWNER) ALLOW REVERSE SCANS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PRREV_ATTESTATION_CFO_IDX ON PERSON_REM_REVIEWER
   (ATTESTATION ASC, CERT_FIRST_OWNER DESC) ALLOW REVERSE SCANS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PERSON_REM_REVIEWER' );