declare
  attestation_id	 numeric(16);
  prop_name      	 varchar(128);
  prop_descr		 varchar(128);
  prop_value		 varchar(128);
  prop_id      		 numeric(16);

  counter            numeric(16);
  cur_attest         sys_refcursor;

begin
  open cur_attest for
  select att.id from attestation att; 
    loop
    fetch cur_attest into attestation_id;
    exit when cur_attest%NOTFOUND;
   
   prop_name  := 'SHOW_PROGRESSBAR_STATS';
   prop_descr := 'Show ProgressBar statistics';
   prop_value := '1';
   select count(1) into counter from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    	select attestation_prop_seq.nextval into prop_id from dual;
    	
        insert into attestation_prop (id, attestation, name, value, description)
   	 	values (prop_id, attestation_id, prop_name, prop_value, prop_descr);
   	end if;
   	
   prop_name  := 'NOTE_ALLOW_FREE_TEXT';
   prop_descr := 'Note free text during removal operation';
   prop_value := '0';
   select count(1) into counter from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    	select attestation_prop_seq.nextval into prop_id from dual;
    	
        insert into attestation_prop (id, attestation, name, value, description)
   	 	values (prop_id, attestation_id, prop_name, prop_value, prop_descr);
   	end if;
   	
   prop_name  := 'NOTE_LOOKUP';
   prop_descr := 'Note lookup during removal operation';	
   prop_value :=  null;
   select count(1) into counter from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    	select attestation_prop_seq.nextval into prop_id from dual;
    	
        insert into attestation_prop (id, attestation, name, value, description)
   	 	values (prop_id, attestation_id, prop_name, prop_value, prop_descr);
   	end if;
   	
   prop_name  := 'REVIEW_STEPS';
   prop_descr := 'Number of review steps';	
   prop_value :=  '1';
   select count(1) into counter from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    	select attestation_prop_seq.nextval into prop_id from dual;
    	
        insert into attestation_prop (id, attestation, name, value, description)
   	 	values (prop_id, attestation_id, prop_name, prop_value, prop_descr);
   	end if;
   	
   prop_name  := 'ALLOW_BULK_SIGNOFF';
   prop_descr := 'Allow bulk signoff operation';	
   select count(1) into counter from attestation_prop attprop where attprop.name = 'ALLOW_BULK_OPERATION' and attprop.attestation = attestation_id;
    if ( counter = 1) then
   	  select count(1) into counter from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
      if ( counter = 0 or counter > 1) then
      	  delete from attestation_prop attprop where attprop.name = prop_name and attprop.attestation = attestation_id;
    	  select attestation_prop_seq.nextval into prop_id from dual;
          select attprop.value into prop_value from attestation_prop attprop where attprop.name = 'ALLOW_BULK_OPERATION' and attprop.attestation = attestation_id;
    	
          insert into attestation_prop (id, attestation, name, value, description)
   	 	  values (prop_id, attestation_id, prop_name, prop_value, prop_descr);
   	  end if;
   	end if;
    
    end loop;
  close cur_attest;

end;
/
commit;