declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE EMPLOYMENT_REVIEW
    ADD ACTION_NOTE VARCHAR(2048)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE EMPLOYMENT_REVIEW
    ADD STEP NUMERIC(2) DEFAULT 1
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE EMPLOYMENT_REVIEW
    ADD REVIEW_PROCESS VARCHAR(32)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX EMP_REV_ATTESTATION_PER_IDX ON EMPLOYMENT_REVIEW
  (ATTESTATION, PERSON)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX EMP_REV_ATT_SIG_RSTATE_IDX ON EMPLOYMENT_REVIEW
  (ATTESTATION, SIGNED_OFF, REVIEW_STATE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMPLOYMENT_REVIEW' );

UPDATE EMPLOYMENT_REVIEW SET STEP = 1 WHERE STEP IS NULL;
