declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE EMPLOYMENT_REVIEW_PWDMAN_H
  (
   ID                             NUMERIC(16)        NOT NULL,
   EMPLOYMENT_REVIEW_H            NUMERIC(16)		NOT NULL,
   PWDMANAGEMENT_CODE             VARCHAR(256),
   IS_DEFAULT               	  NUMERIC(1),
   PWDCFG_NAME               	  VARCHAR(256),
   PWDCFG_DESCRIPTION        	  VARCHAR(512),
   ATTR1                          VARCHAR(256),
   ATTR2                          VARCHAR(256),
   ATTR3                          VARCHAR(256),
   ATTR4                          VARCHAR(256),
   ATTR5                          VARCHAR(256),
   ATTR6                          VARCHAR(256),
   ATTR7                          VARCHAR(256),
   ATTR8                          VARCHAR(256),
   ATTR9                          VARCHAR(256),
   ATTR10                         VARCHAR(256)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN_H
    ADD CONSTRAINT EMPLOYMENT_REV_PWDMAN_H_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H TO IGA;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H TO IGACONN;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN_H TO REP;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN_H 
   ADD CONSTRAINT EMP_REV_PWDM_H_EMP_REV_H_FK
   FOREIGN KEY (EMPLOYMENT_REVIEW_H)
   REFERENCES EMPLOYMENT_REVIEW_H (ID)
   ON DELETE CASCADE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=
'CREATE SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_H_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';	

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMPLOYMENT_REVIEW_PWDMAN_H' );

GRANT USAGE ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO REP;
