declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE DEVICE_FEATURE_SETTINGS
  (
    ID                           NUMERIC(16,0)  NOT NULL,
    FEATURE_ENABLED              NUMERIC(1,0)   NOT NULL DEFAULT 0,
    MOBILE_ACCOUNT_NAME          VARCHAR(256),
    MOBILE_FEATURE_VERSION       VARCHAR(20),
    OIDC_TOKEN_GENERATE_URL      VARCHAR(512),
    OIDC_TOKEN_REGENERATE_URL    VARCHAR(512),
    OIDC_INVALIDATE_URL          VARCHAR(512),
    EXTERNAL_URL                 VARCHAR(512),
    QR_TOKEN_VALIDITY            NUMERIC(16,0),
    OIDC_ACCESS_TOKEN_VALIDITY   NUMERIC(16,0),
    OIDC_REFRESH_TOKEN_VALIDITY  NUMERIC(16,0)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE DEVICE_FEATURE_SETTINGS
    ADD CONSTRAINT DEVICE_FEATURE_SETTINGS_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE DEVICE_FEATURE_SETTINGS' );

GRANT ALL ON DEVICE_FEATURE_SETTINGS TO IGA;
GRANT ALL ON DEVICE_FEATURE_SETTINGS TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE DEVICE_FEATURE_SETTINGS_SEQ
    AS NUMERIC(18)
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE DEVICE_FEATURE_SETTINGS_SEQ TO IGA;
GRANT USAGE ON SEQUENCE DEVICE_FEATURE_SETTINGS_SEQ TO IGACONN;
