declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE CHANGELOG
    ADD COLUMN PWDMANAGEMENT_FOR_DELETE NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
 ALTER TABLE CHANGELOG
    DROP CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE CHANGELOG
    ADD CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
    FOREIGN KEY (PWDMANAGEMENT)
    REFERENCES PWDMANAGEMENT (ID)
    ON DELETE SET NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE INDEX CHLOG_PWDMANFORDELETE_IDX ON CHANGELOG
  (PWDMANAGEMENT_FOR_DELETE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE INDEX CHLOG_PWDMAN_IDX ON CHANGELOG
  (PWDMANAGEMENT)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE CHANGELOG' );