declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE DEVICE_INFO
  (
	DEVICE_ID 			NUMERIC(16,0) 	NOT NULL,
	USER_ID 			VARCHAR(128) 	NOT NULL,
	QR_TOKEN 			VARCHAR(32) 	NOT NULL,
	QR_GENERATION_TIME 	NUMERIC(16,0) 	NOT NULL,
	OIDC_ACCESS_TOKEN 	VARCHAR(1024) 	NOT NULL,
	OIDC_REFRESH_TOKEN 	VARCHAR(255) 	NOT NULL,
	OIDC_TOKEN_EXPIRY 	NUMERIC(10,0) 	NOT NULL,
	DEVICE_STATE 		NUMERIC(16,0) 	NOT NULL,
	APPLICATION_VERSION VARCHAR(24),
	FINGERPRINT_SUPPORT NUMERIC(1,0),
	FRONTCAMERA_SUPPORT NUMERIC(1,0),
	FACE_SUPPORT 		NUMERIC(1,0),
	PLATFORM_TYPE 		VARCHAR(16),
	DEVICE_NAME 		VARCHAR(255) 	NOT NULL,
	DEVICE_TYPE 		VARCHAR(16),
	APPLICATION_ID 		VARCHAR(40),
	DEVICE_UUID 		VARCHAR(40),
	OS_VERSION 			VARCHAR(24),
	VERIFY_SDK_VERSION 	VARCHAR(24),
	PUSHTOKEN 			VARCHAR(32)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE DEVICE_INFO
    ADD CONSTRAINT DEVICE_INFO_PK 
    PRIMARY KEY (DEVICE_ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE DEVICE_INFO' );

GRANT ALL ON DEVICE_INFO TO IGA;
GRANT ALL ON DEVICE_INFO TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE DEVICE_INFO_SEQ
    AS NUMERIC(18)
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE DEVICE_INFO_SEQ TO IGA;
GRANT USAGE ON SEQUENCE DEVICE_INFO_SEQ TO IGACONN;
