CREATE OR REPLACE TRIGGER TRG_PWDMANAGEMENT_AFTER
  AFTER DELETE ON PWDMANAGEMENT
  FOR EACH ROW
declare
  code_oper  varchar(128);

  counter    numeric(16);

begin

  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

  if (deleting) then
    --se cancelliamo l'account della configurazione profilemanager usciamo dal trigger
    if (deleting and :old.pwdcfg = 1) then
      return;
    end if;

    insert into eventpm
      (id, person, cod_operation, operation, pwdcfg, attr1)
    values
      (eventpm_seq.nextval,
       :old.person,
       code_oper,
       9,
       :old.pwdcfg,
       :old.code);
    return;
  end if;

end TRG_PWDMANAGEMENT_AFTER;
/