declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE PWDMANAGEMENT_STATUS
  (
	  ID                             NUMERIC(16)         NOT NULL,
  	  PERSON                         NUMERIC(16),
  	  TARGET                         VARCHAR(256)        NOT NULL,
  	  ACCOUNT_CODE                   VARCHAR(256)        NOT NULL,
 	  PWDMANAGEMENT                  NUMERIC(16),
	  PWDCFG		                 NUMERIC(16)         NOT NULL,
      STATUS                         NUMERIC(16)         DEFAULT 0 NOT NULL,
  	  VERIFY_DATE                    DATE,
  	  STATUS_SUSPENSION              NUMERIC(16)         DEFAULT 0 NOT NULL,
  	  VERIFY_DATE_SUSPENSION         DATE,
  	  STATUS_MODIFICATION            NUMERIC(16)         DEFAULT 0 NOT NULL,
  	  VERIFY_DATE_MODIFICATION       DATE,
  	  STATUS_PASSWORD                NUMERIC(16)         DEFAULT 0 NOT NULL,
  	  VERIFY_DATE_PASSWORD           DATE,
  	  SYNCH_MESSAGE                  VARCHAR(256),
  	  CHANGELOG                      NUMERIC(16),
  	  ATTR1                          VARCHAR(256),
   	  ATTR2                          VARCHAR(256),
  	  ATTR3                          VARCHAR(256),
  	  ATTR4                          VARCHAR(256),
  	  ATTR5                          VARCHAR(256),
  	  CREATION_USER                  VARCHAR(128),
  	  CREATION_DATE                  DATE                DEFAULT CURRENT_DATE,
  	  LAST_MOD_USER                  VARCHAR(128),
  	  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT_STATUS
    ADD CONSTRAINT PWDMANAGEMENT_STATUS_PK 
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDMANAGEMENT_STATUS' );

GRANT ALL ON PWDMANAGEMENT_STATUS TO IGA;
GRANT ALL ON PWDMANAGEMENT_STATUS TO IGACONN;
GRANT ALL ON PWDMANAGEMENT_STATUS TO REP;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE PWDMANAGEMENT_STATUS_SEQ
    AS NUMERIC(18)
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE PWDMANAGEMENT_STATUS_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_STATUS_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_STATUS_SEQ TO REP;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PWDMANAGEMENT_STATUS
   ADD CONSTRAINT PWDMANAGEMENT_STATUS_PERSON_FK
   FOREIGN KEY (PERSON)
   REFERENCES PERSON (ID)
   ON DELETE CASCADE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PWDMANAGEMENT_STATUS
   ADD CONSTRAINT PWDMANAGEMENT_STATUS_PWDMAN_FK
   FOREIGN KEY (PWDMANAGEMENT)
   REFERENCES PWDMANAGEMENT (ID)
   ON DELETE SET NULL
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE PWDMANAGEMENT_STATUS
   ADD CONSTRAINT PWDMANAGEMENT_STATUS_PWDCFG_FK
   FOREIGN KEY (PWDCFG)
   REFERENCES PWDCFG (ID)
   ON DELETE CASCADE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_PERSON_IDX ON PWDMANAGEMENT_STATUS
  (PERSON)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_PWDMAN_IDX ON PWDMANAGEMENT_STATUS
  (PWDMANAGEMENT)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_PWDCFG_IDX ON PWDMANAGEMENT_STATUS
  (PWDCFG)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_ACCOUNT_IDX ON PWDMANAGEMENT_STATUS
  (ACCOUNT_CODE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_IDX ON PWDMANAGEMENT_STATUS
  (STATUS)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_MODIFICATION_IDX ON PWDMANAGEMENT_STATUS
  (STATUS_MODIFICATION)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_PASSWORD_IDX ON PWDMANAGEMENT_STATUS
  (STATUS_PASSWORD)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX PWDMAN_STATUS_SUSPENSION_IDX ON PWDMANAGEMENT_STATUS
  (STATUS_SUSPENSION)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/







