declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE SOURCE_INFO
  (
  	ID                             NUMERIC(16)         NOT NULL,
	ENTITY                         NUMERIC(16),
  	ENTITY_ID                      NUMERIC(16),
  	SOURCE_TYPE					   NUMERIC(16),
  	SOURCE_ID					   NUMERIC(16),
  	SOURCE_NAME					   VARCHAR(256),
	ACTION_TYPE					   VARCHAR(256),
 	ACTION_CAUSE				   VARCHAR(256),
  	STATE                          NUMERIC(16)         DEFAULT 0,
  	ATTR1                          VARCHAR(256),
 	ATTR2                          VARCHAR(256),
  	ATTR3                          VARCHAR(256),
  	ATTR4                          VARCHAR(256),
  	ATTR5                          VARCHAR(256),
  	LAST_MOD_USER                  VARCHAR(128),
  	LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE SOURCE_INFO
    ADD CONSTRAINT SOURCE_INFO_PK 
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE SOURCE_INFO' );

GRANT ALL ON SOURCE_INFO TO IGA;
GRANT ALL ON SOURCE_INFO TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE SOURCE_INFO_SEQ
    AS NUMERIC(18)
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE SOURCE_INFO_SEQ TO IGA;
GRANT USAGE ON SEQUENCE SOURCE_INFO_SEQ TO IGACONN;
