CREATE OR REPLACE VIEW PERSON_OUTOFSYNC AS
select
	person,
	max( account_oos ) as account_oos,
	max( permission_oos ) as permission_oos,
	max( services_oos ) as services_oos
from
	(
		select
			case
	        	when account_oos.person is not null then account_oos.person
	        	when permission_oos.person is not null then permission_oos.person
	        	when services_oos.person is not null then services_oos.person
			end as person,
			case
				when account_oos.account_oos is null then 0
				when account_oos.account_oos is not null then account_oos.account_oos
			end as account_oos,
			case
				when permission_oos.permission_oos is null then 0
				when permission_oos.permission_oos is not null then permission_oos.permission_oos
			end as permission_oos,
			case
				when services_oos.services_oos is null then 0
				when services_oos.services_oos is not null then services_oos.services_oos
			end as services_oos
		from
			(
				select
					person,
					1 as account_oos
				from
					pwdmanagement_status
				where
					person is not null
					and (
						status = 101
						or status = 103
						or status = 104
						or status = 111
						or status = 113
						or status = 114
						or status_suspension = 201
						or status_suspension = 203
						or status_suspension = 204
						or status_suspension = 211
						or status_suspension = 213
						or status_suspension = 214
						or status_modification = 301
						or status_modification = 303
						or status_modification = 304
						or status_password = 401
						or status_password = 403
						or status_password = 404
					)
			) account_oos full
		outer join (
				select
					person,
					1 as permission_oos
				from
					person_profile pp
				where
					person is not null
					and status <> 2
			) permission_oos on
			account_oos.person = permission_oos.person full
		outer join (
				select
					pp.person,
					1 as services_oos
				from
					person_profile pp,
					person_profile_service pps
				where
					person is not null
					and pp.id = pps.person_profile
					and pps.status <> 2
			) services_oos on
			account_oos.person = services_oos.person
	) final_query
group by
	person
;

GRANT SELECT ON PERSON_OUTOFSYNC TO IGA;
GRANT SELECT ON PERSON_OUTOFSYNC TO IGACONN;
GRANT SELECT ON PERSON_OUTOFSYNC TO REP;
