declare
  pwdcfg_id	 		 numeric(16);
  target_name      	 varchar(128);
  pwdmstatus_id		 numeric(16);
  pwdm_id 		     numeric(16);
  pwdm_person		 numeric(16);
  pwdm_code			 varchar(128);
  pwdm_cl			 numeric(16);

  cur_pwdcfg         sys_refcursor;
  cur_target         sys_refcursor;
  cur_pwdmgmt        sys_refcursor;

BEGIN
  open cur_pwdcfg for
  select pc.id from pwdcfg pc where (pc.sync=1 or pc.sync=2) and pc.id > 99;
    loop
    fetch cur_pwdcfg into pwdcfg_id;
    exit when cur_pwdcfg%NOTFOUND;
    
    open cur_target for
  		select t.name from target t where t.pwdcfg = pwdcfg_id;
    	loop
    	fetch cur_target into target_name;
    	exit when cur_target%NOTFOUND;
    
   		open cur_pwdmgmt for
 			select p.id,  p.person, p.code, p.changelog 
 			from pwdmanagement p where p.pwdcfg = pwdcfg_id;
    		loop
    		fetch cur_pwdmgmt into pwdm_id, pwdm_person, pwdm_code, pwdm_cl;
    		exit when cur_pwdmgmt%NOTFOUND;
    		
    		select pwdmanagement_status_seq.nextval into pwdmstatus_id from dual;
    
    		INSERT INTO pwdmanagement_status (id, person, target, account_code, pwdmanagement, pwdcfg, 
				status, verify_date, status_suspension, verify_date_suspension, status_modification, verify_date_modification, status_password, 
				verify_date_password, changelog, creation_user, creation_date, last_mod_user, last_mod_time)
			VALUES (pwdmstatus_id, pwdm_person, target_name, pwdm_code, pwdm_id, pwdcfg_id, 102, current_date, 202, current_date, 302, current_date, 402, current_date, pwdm_cl, 'MIGRATION', current_date, 'MIGRATION', current_date);
		    
			end loop;
  		 close cur_pwdmgmt;
  		 
  	 end loop;
  	close cur_target;
  	
  commit; --commit at the end of each pwdcfg
  
 end loop;
 close cur_pwdcfg;

end;
/
commit;