set define off
declare
  im_id         numeric(16);
  im_name       varchar(256) := 'AGC';
  
  fcpass_id     numeric(16);
  fcpass_name   varchar(256) := 'password'; --9
  
  fevtpass_id   numeric(16);
  fevtpass_name varchar(256) := '<Empty>';

  fc_id         numeric(16);
  fc_name       varchar(256) := 'hiddenSharedSpace'; --10
  
  fevt_id       numeric(16);
  fevt_name     varchar(256) := '<Empty>';
  
  f_id          numeric(16);
  f_name        varchar(256) := 'PasswordSharedRules';
  f_desc        varchar(256) := 'password flow holding shared rules';

  varLob        clob := 'package te0b9aeda
'||'
'||'import com.engiweb.profilemanager.common.bean.UserBean;
'||'import com.engiweb.profilemanager.common.bean.AccountBean;
'||'import com.engiweb.profilemanager.common.bean.PwdCfgBean;
'||'import com.engiweb.profilemanager.common.ruleengine.action.UtilAction;
'||'import java.util.Locale;
'||'import java.util.ResourceBundle;
'||'
'||'global com.engiweb.pm.dao.db.DAO sql;
'||'global com.engiweb.logger.impl.Log4JImpl logger;
'||'
';


 counter       numeric(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  --password flow_event_type section
  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fcpass_name );
  if ( counter = 1 ) then
    select t.id into fcpass_id from flow_context t where lower ( t.name ) = lower ( fcpass_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;
  
  select count(1) into counter from flow_event_type t
  where t.flow_context = fcpass_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevtpass_name );
  if ( counter = 1 ) then
    select t.id into fevtpass_id from flow_event_type t
    where t.flow_context = fcpass_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevtpass_name );
  else
   select flow_event_type_seq.nextval into fevtpass_id from dual;
   insert into flow_event_type (ID, FLOW_CONTEXT, NAME, DESCRIPTION, STATE, ATTR1, ATTR2, ATTR3, ATTR4, ATTR5, CREATION_USER, CREATION_DATE, LAST_MOD_USER, LAST_MOD_TIME, IDEAS_MODULE, SHARED_FLOW)
	values (fevtpass_id, fcpass_id, fevt_name, null, 0, null, null, null, null, null, null, current_date, null, current_date, im_id, null);
  
	commit;
  end if;
  --end password flow_event_type section
  
   select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
  select flow_event_type_seq.nextval into fevt_id from dual;
   insert into flow_event_type (ID, FLOW_CONTEXT, NAME, DESCRIPTION, STATE, ATTR1, ATTR2, ATTR3, ATTR4, ATTR5, CREATION_USER, CREATION_DATE, LAST_MOD_USER, LAST_MOD_TIME, IDEAS_MODULE, SHARED_FLOW)
	values (fevt_id, fc_id, fevt_name, null, 0, null, null, null, null, null, null, current_date, null, current_date, im_id, null);
  
	commit;
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 0 ) then
    select flow_seq.nextval into f_id from dual;
    insert into flow (ID, FLOW_EVENT_TYPE, NAME, DESCRIPTION, STATE, FLOW_LOB, ATTR1, ATTR2, ATTR3, ATTR4, ATTR5, CREATION_USER, CREATION_DATE, LAST_MOD_USER, LAST_MOD_TIME, IDEAS_MODULE, SHARED_FLOW)
    values (f_id, fevt_id, f_name, f_desc, 0, varLob, null, null, null, null, null, null, current_date, null, current_date, im_id, null);
    
    --update flow_event_type password shared flow
	update flow_event_type set shared_flow = f_id where id = fevtpass_id;
  end if;

end;
/
commit;
set define on