declare
  rq_id            numeric(16);
  rq_name          varchar2(256) := 'Events. Inbound, Identity';
  rqd              clob;
  counter          numeric(16);
begin

 rqd := 'select distinct ue.pm_code               as USER_CODE,
'||'                ue.given_name            as USER_NAME,
'||'                ue.surname               as USER_SURNAME,
'||'                ue.user_type             as USER_TYPE,
'||'                ue.processed             as PROCESSED,
'||'                ue.last_mod_user         as LAST_MOD_USER,
'||'                ue.last_mod_time         as LAST_MOD_TIME,
'||'                ue.post_event            as POST_EVENT,
'||'                ue.skip                  as SKIP,
'||'                ue.action_type           as ACTION_TYPE,
'||'                ue.action_cause          as ACTION_CAUSE,
'||'                ue.action_type_last      as ACTION_TYPE_LAST,
'||'                ue.action_cause_last     as ACTION_CAUSE_LAST,
'||'                ue.gender                as USER_GENDER,
'||'                ue.birth_place           as USER_BIRTH_PLACE,
'||'                ue.birth_country         as USER_BIRTH_COUNTRY,
'||'                ue.identification_number as USER_IDENTIF_NUMBER,
'||'                ue.currentou as USER_CURRENTOU_CODE,
'||'                ue.account_expiry_date as ACCOUNT_EXPIRY_DATE,
'||'                ue.birthday as USER_BIRTHDAY,
'||'                ue.nation as USER_NATION,
'||'                ue.zipcode as USER_ZIPCODE,
'||'                ue.country as USER_COUNTRY,
'||'                ue.phone_number as USER_PHONE_NUMBER,
'||'                ue.disabled as ACCOUNT_STATUS,
'||'                case
'||'                  when ei.operation=1 then ''Add user''
'||'                  when ei.operation=2 then ''Modify User''
'||'                  when ei.operation=3 then ''Remove User''
'||'                  when ei.operation=9 then ''Add Organizational Unit''
'||'                  when ei.operation=10 then ''Modify Organizational Unit''
'||'                  when ei.operation=11 then ''Remove Organizational Unit''
'||'                  when ei.operation=12 then ''Move User''
'||'                end as EVENT_OPERATION,
'||'                case
'||'                  when ei.state=0 then ''Unprocessed''
'||'                  when ei.state=1 then ''Success''
'||'                  when ei.state=2 then ''Error''
'||'                end as EVENT_STATUS,
'||'                ei.ext_attr1 as EVENT_VALUE1,
'||'                ei.ext_attr2 as EVENT_VALUE2,
'||'                ei.ext_attr3 as EVENT_VALUE3,
'||'                ei.ext_attr4 as EVENT_VALUE4,
'||'                ei.ext_attr5 as EVENT_VALUE5,
'||'                ei.ext_attr6 as EVENT_VALUE6,
'||'                ei.ext_attr7 as EVENT_VALUE7,
'||'                ei.ext_attr8 as EVENT_VALUE8,
'||'                ei.ext_attr9 as EVENT_VALUE9,
'||'                ei.ext_attr10 as EVENT_VALUE10,
'||'                ei.date_event as EVENT_DATE,
'||'                ei.date_process as PROCESS_EVENT_DATE
'||'  from #pmschema#.event_in ei, #pmschema#.user_erc ue
'||' where ei.ext_table = ue.id
'||'   and lower(ei.erc) = ''user_erc''
'||'   and upper(ue.given_name) like upper(''#user_name#'')
'||'   and upper(ue.surname) like upper(''#user_surname#'')
'||'   and upper(ue.pm_code) like upper(''#user_code#'')
'||'   and ei.operation = #event_operation#
'||'   and ei.state = #event_state#
'||'   and ei.date_event between to_timestamp(''#start_date#'', ''#ideas_simpledate# hh24:mi:ss,ff6'') and
'||'       to_timestamp(''#end_date#'', ''#ideas_simpledate# hh24:mi:ss,ff6'')
'||' order by ue.pm_code
';


  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  
  if ( counter = 1 ) then
     select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
     
	 update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/
commit;
