CREATE OR REPLACE TRIGGER TRG_PWDMANAGEMENT_DEL_BEFORE
  BEFORE DELETE ON PWDMANAGEMENT
  FOR EACH ROW
declare
  cur_pwdcfg sys_refcursor;

feedB BOOLEAN;

v_target VARCHAR(256);

code_oper VARCHAR(128);

counter numeric(16);

BEGIN

  IF (:old.person IS NULL) THEN
    RETURN;
  END IF;
	
  SELECT COUNT(1) INTO counter FROM tmp_codoperation;

  IF (counter = 0) THEN
    RAISE_APPLICATION_ERROR(-20200,
                            'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');

  elsif (counter = 1) THEN
    SELECT code INTO code_oper FROM tmp_codoperation;

  elsif (counter > 1) THEN
    RAISE_APPLICATION_ERROR(-20201,
                            'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  END IF;

  if (code_oper is not null and INSTR(code_oper, 'ARM_', 1, 1) = 1) then
    feedB := true;
  else
    feedB := false;
  end if;

    --manage the insert account for feedback
    IF (feedB) THEN
      OPEN cur_pwdcfg FOR
        SELECT DISTINCT t.value
          FROM pwdcfg pwd, target t
         WHERE pwd.id = :old.pwdcfg
           AND pwd.id = t.pwdcfg
		  AND pwd.sync = 2;
      LOOP
        FETCH cur_pwdcfg
          INTO v_target;
        EXIT WHEN cur_pwdcfg % NOTFOUND;
        -- controllo del target
        IF (v_target IS NOT NULL) THEN
          INSERT INTO feedback
            (id, authorizations, APPLICATION, cod_operation, operation)
          VALUES
            (feedback_seq.nextval, :old.id, v_target, code_oper, 9);
        END IF;
      END LOOP;

      CLOSE cur_pwdcfg;
      -- fine propagazione su feedback
    END IF;

END TRG_PWDMANAGEMENT_DEL_BEFORE;
/