declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE EXCEPTION_STATUS_MAP
  (
	ID 								NUMERIC(16) 		NOT NULL,
	ENTITY							NUMERIC(16),
	EXCEPTION		 				VARCHAR(256),
	STATUS_KEY 						VARCHAR(256)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE EXCEPTION_STATUS_MAP
    ADD CONSTRAINT EXCEPTION_STATUS_MAP_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EXCEPTION_STATUS_MAP TO IGA;
GRANT ALL ON EXCEPTION_STATUS_MAP TO IGACONN;
GRANT SELECT ON EXCEPTION_STATUS_MAP TO REP;


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=
'CREATE SEQUENCE EXCEPTION_STATUS_MAP_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';	

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EXCEPTION_STATUS_MAP' );

GRANT USAGE ON SEQUENCE EXCEPTION_STATUS_MAP_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EXCEPTION_STATUS_MAP_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE EXCEPTION_STATUS_MAP_SEQ TO REP;
