declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE FIXED_ENTITY_SCOPE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  CACHE 1000
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE FIXED_ENTITY_SCOPE_SEQ TO IGA;
GRANT USAGE ON SEQUENCE FIXED_ENTITY_SCOPE_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE FIXED_ENTITY_SCOPE_SEQ TO REP;
/ 

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ADD COLUMN ID NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ADD COLUMN LOOKUP_SCOPE NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE FIXED_ENTITY_SCOPE' );
/

UPDATE FIXED_ENTITY_SCOPE SET ID = FIXED_ENTITY_SCOPE_SEQ.NEXTVAL WHERE ID IS NULL;
/
 
 declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ALTER COLUMN ID SET NOT NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE FIXED_ENTITY_SCOPE' );
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE FIXED_ENTITY_SCOPE
    ADD CONSTRAINT FES_ID_UK
    UNIQUE (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX FES_ID_IDX ON FIXED_ENTITY_SCOPE
  (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE FIXED_ENTITY_SCOPE' );
/ 

CREATE OR REPLACE TRIGGER TRG_FES_ID
  BEFORE INSERT OR UPDATE ON FIXED_ENTITY_SCOPE
  FOR EACH ROW
declare
begin
	if(:new.id is null) then 
	  :new.id := fixed_entity_scope_seq.nextval;
	end if;
return;
end TRG_FES_ID;

/
