declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=' 
 CREATE TABLE FIXED_ENTITY_LOOKUP_SCOPE
(
  	ID 								NUMERIC(16) 		NOT NULL,
	FIXED_ENTITY	 				NUMERIC(16) 		NOT NULL,
	OBJECT_ID						NUMERIC(16),
	OBJECT_NAME		 				VARCHAR(512),
	OBJECT_CODE		 				VARCHAR(512),
	ATTR1 							VARCHAR(256),
	ATTR2 							VARCHAR(256),
	ATTR3 							VARCHAR(256),
	ATTR4 							VARCHAR(256),
	ATTR5 							VARCHAR(256)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE FIXED_ENTITY_LOOKUP_SCOPE
    ADD CONSTRAINT FIXED_ENTITY_LOOKUP_SCOPE_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
   ALTER TABLE FIXED_ENTITY_LOOKUP_SCOPE
   ADD CONSTRAINT FELS_FIXED_ENTITY_FK
   FOREIGN KEY (FIXED_ENTITY)
   REFERENCES FIXED_ENTITY_SCOPE (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX FELS_FIXED_ENTITY_IDX ON FIXED_ENTITY_LOOKUP_SCOPE
  (FIXED_ENTITY)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE TO IGA;
GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE TO IGACONN;
GRANT SELECT ON FIXED_ENTITY_LOOKUP_SCOPE TO REP;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE FIXED_ENTITY_LOOKUP_SCOPE' );
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE FIXED_ENTITY_LOOKUP_SCOPE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  CACHE 1000
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO IGA;
GRANT USAGE ON SEQUENCE FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO REP;

