declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE S_USER
    ADD FULLNAME VARCHAR(1024)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE S_USER
    ADD FULLNAMEREV VARCHAR(1024)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE S_USER' );
/

declare
  cur          	sys_refcursor;
  
  p_id			numeric(16);
  p_name     	varchar(256);
  p_surname     varchar(256);
  
  counter 		numeric(16);

begin
  open cur for
    select p.id, p.firstname, p.lastname from s_user p;
  
  counter := 0;
  
  loop
    fetch cur into p_id, p_name, p_surname;
    exit when cur%notfound;
	
    counter := counter + 1;
    
	IF((p_surname IS NULL OR p_surname='') AND (p_name IS NULL OR p_name=''))
	THEN
		update s_user p set fullname = null, fullnamerev = null where p.id = p_id;
	ELSIF(p_surname IS NULL OR p_surname='')
	THEN
		update s_user p set fullname = p_name, fullnamerev = p_name where p.id = p_id;
	ELSIF(p_name IS NULL OR p_name='')
	THEN
		update s_user p set fullname = p_surname, fullnamerev = p_surname where p.id = p_id;
	ELSE
		update s_user p set fullname = (p_name || ' ' || p_surname), fullnamerev = (p_surname || ' ' || p_name) where p.id = p_id;
	END IF;
    
   	if(counter = 10000) then 
   	    commit; 
   	    counter := 0;
   	end if;
   
  end loop;
  close cur;
  commit;
end;
/

CREATE OR REPLACE TRIGGER TRG_SUSER_FULLNAME
  BEFORE UPDATE ON S_USER
  FOR EACH ROW
declare
begin
  if((:new.lastname IS NULL OR :new.lastname='') AND (:new.firstname IS NULL OR :new.firstname=''))
  THEN
    :new.fullname := null;
    :new.fullnamerev := null;
    return;
  end if;
  
  if(:new.lastname IS NULL OR :new.lastname='')
  THEN
    :new.fullname := :new.firstname;
    :new.fullnamerev := :new.firstname;
    return;
  end if;
  
  if(:new.firstname IS NULL OR :new.firstname='')
  THEN
    :new.fullname := :new.lastname;
    :new.fullnamerev := :new.lastname;
    return;
  end if;
  
  :new.fullname := (:new.firstname || ' ' || :new.lastname);
  :new.fullnamerev := (:new.lastname || ' ' || :new.firstname);
return;
end TRG_SUSER_FULLNAME;
/
