set define off

declare
  im_id         numeric(16);
  im_name       varchar(256) := 'AGC';

  fc_id         numeric(16);
  fc_name       varchar(256) := 'system';
  
  fevt_id       numeric(16);
  fevt_name     varchar(256) := 'IN';
  
  f_id          numeric(16);
  f_name        varchar(256) := 'USER_BEFORE';

 
  fr_id         numeric(16);
  fr_name       varchar(256) := 'Transform ADD To MODIFY [V5.2.6]';

  fr_lob        clob;

  counter       numeric(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 1 ) then
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
   
    SELECT t.rule_lob into fr_lob FROM flow_rule t WHERE t.id = fr_id;

    update flow_rule set rule_lob = SYSFUN.replace(fr_lob, 'eventin.setExtAttr10(null);',' ') where id = fr_id;
  end if;

end;
/

declare
  im_id         numeric(16);
  im_name       varchar(256) := 'AGC';

  fc_id         numeric(16);
  fc_name       varchar(256) := 'system';
  
  fevt_id       numeric(16);
  fevt_name     varchar(256) := 'IN';
  
  f_id          numeric(16);
  f_name        varchar(256) := 'ORGUNIT_BEFORE';

  f_lob         clob := 'package tBEFORE_ORGUNIT1;
'||'
'||'import com.engiweb.logger.impl.Log4JImpl;
'||'import com.engiweb.pm.entity.BeanList;
'||'import com.engiweb.profilemanager.backend.dao.db.SQLH;
'||'import com.engiweb.profilemanager.common.bean.AccountBean;
'||'import com.engiweb.profilemanager.common.bean.ExternalInfo;
'||'import com.engiweb.profilemanager.common.bean.OrgUnitBean;
'||'import com.engiweb.profilemanager.common.bean.OrgUnitErcBean;
'||'import com.engiweb.profilemanager.common.bean.PwdCfgBean;
'||'import com.engiweb.profilemanager.common.bean.UserBean;
'||'import com.engiweb.profilemanager.common.bean.UserErcBean;
'||'import com.engiweb.profilemanager.common.bean.event.EventBean;
'||'import com.engiweb.profilemanager.common.bean.event.EventInBean;
'||'import com.engiweb.profilemanager.common.ruleengine.action.OrgUnitAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.UserAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.UtilAction;
'||'import com.engiweb.toolkit.common.DBMSException;
'||'
'||'global com.engiweb.profilemanager.backend.dao.db.SQLH sql;
'||'global com.engiweb.logger.impl.Log4JImpl logger;
'||'
'||'
'||'
';
 
  fr_id         numeric(16);
  fr_name       varchar(256) := 'Transform ADD To MODIFY [V5.2.6]';
  fr_desc       varchar(512) := '[ V5.2.6 - 2019-11-28 ]';
  
  fr_lob        clob := 'rule "Transform ADD to MODIFY [V5.2.6]"
'||'	 when
'||'		event : EventBean(  )
'||'		orgUnitErcBean : OrgUnitErcBean(  )
'||'
'||'	 then
'||'
'||'  // [ V5.2.6 - 2019-11-28 ]
'||'
'||'  logger.debug("OU input transformation, event:" + event);
'||'
'||'  EventInBean eventin = (EventInBean) event;
'||'  eventin.setExtAttr10(null);
'||'
'||'  final long ADD = 9;
'||'  final long MODIFY = 10;
'||'  final long DISCARDED = 99;
'||'
'||'  long currentOperation = eventin.getOperation();
'||'  String ouCode = (String) orgUnitErcBean.getAttribute("OU");
'||'  String ouTableId = (String) orgUnitErcBean.getAttribute("ID");
'||'
'||'  // ADD but the OU already exists:
'||'  // Transform ADD to MODIFY
'||'  // NOTE: it can happen because OUs created from the Console haven''t the record
'||'  // in the external table.
'||'
'||'  if (currentOperation == ADD) {
'||'    // look for the Ou
'||'    OrgUnitBean ouBean = UtilAction.findOrgUnitByCode(sql, ouCode);
'||'    if (ouBean != null) {
'||'      eventin.setOperation(MODIFY);
'||'      // save the real operation code
'||'      eventin.setExtAttr10(Long.toString(currentOperation));
'||'
'||'      // allign the orgUnit fk to orgUnitErc (attr1)
'||'      ouBean.setAttr1(ouTableId);
'||'      OrgUnitAction.modifyOrgUnit(sql, ouBean);
'||'    }
'||'  }
'||'end
'||'
';

  counter       numeric(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
	
	update flow set flow_lob = f_lob where id = f_id;
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );

    update flow_rule set description = fr_desc where id = fr_id;

    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
