declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE AUDIT_PROFILE
  (
	ID 								NUMERIC(16) 		NOT NULL,
	EVENT_ID						NUMERIC(16),
	ENTITY		 					NUMERIC(16),
	AUDIT_ENABLE 					NUMERIC(1)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE AUDIT_PROFILE
    ADD CONSTRAINT AUDIT_PROFILE_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON AUDIT_PROFILE TO IGA;
GRANT ALL ON AUDIT_PROFILE TO IGACONN;
GRANT SELECT ON AUDIT_PROFILE TO REP;


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=
'CREATE SEQUENCE AUDIT_PROFILE_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
    ';	

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE AUDIT_PROFILE' );

GRANT USAGE ON SEQUENCE AUDIT_PROFILE_SEQ TO IGA;
GRANT USAGE ON SEQUENCE AUDIT_PROFILE_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE AUDIT_PROFILE_SEQ TO REP;
