declare
  stat        varchar(4000);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE AUDIT_DATA
  (
	ID 								NUMERIC(16)		NOT NULL, 
	AUDIT_LOG 						NUMERIC(16) 	NOT NULL, 
	OPERATOR 						VARCHAR(256)	DEFAULT ''N/A'', 
	OPERATOR_ID 					VARCHAR(128)	DEFAULT ''N/A'', 
	EVENT_ID 						NUMERIC(16) 	NOT NULL, 
	EVENT 							VARCHAR(256)	DEFAULT ''N/A'', 
	OPERATION_CODE 					VARCHAR(256)	DEFAULT ''N/A'', 
	EVENT_DATE 						TIMESTAMP(6),
	BENEFICIARY_TYPE 				VARCHAR(256)	DEFAULT ''N/A'', 
	BENEFICIARY_ID 					NUMERIC(16)		DEFAULT 0, 
	BENEFICIARY 					VARCHAR(256)	DEFAULT ''N/A'', 
	BENEFICIARY_ATTR1 				VARCHAR(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR2 				VARCHAR(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR3 				VARCHAR(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR4 				VARCHAR(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR5 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_TYPE 					VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ID 					NUMERIC(16)		DEFAULT 0,
	METADATA1 						VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ATTR1 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ATTR2 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ATTR3 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ATTR4 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA1_ATTR5 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_TYPE 					VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ID 					NUMERIC(16) 	DEFAULT 0,
	METADATA2 						VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ATTR1 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ATTR2 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ATTR3 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ATTR4	 				VARCHAR(256)	DEFAULT ''N/A'',
	METADATA2_ATTR5 				VARCHAR(256)	DEFAULT ''N/A'',
	ATTRIBUTE						VARCHAR(128)	DEFAULT ''N/A'',
	OLD_VALUE 						CLOB(2G)		DEFAULT ''N/A'',
	NEW_VALUE 						CLOB(2G)		DEFAULT ''N/A'',
	SOURCE_TYPE 					VARCHAR(64)		DEFAULT ''N/A'',
	SOURCE_ID 						NUMERIC(16)		DEFAULT 0, 
	SOURCE_NAME 					VARCHAR(256)	DEFAULT ''N/A'',
	STATUS 							VARCHAR(64)		DEFAULT ''N/A'',
	STATUS_REASON	 				CLOB(2M)		DEFAULT ''N/A'',
	ACTED_AS 						VARCHAR(256)	DEFAULT ''N/A'',
	ACTED_AS_ID 					VARCHAR(64)		DEFAULT ''N/A''
  	)
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
	ALTER TABLE AUDIT_DATA
    ADD CONSTRAINT AUDIT_DATA_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX AUDIT_DATA_EVENTID_IDX ON AUDIT_DATA (EVENT_ID)  ALLOW REVERSE SCANS 
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX AUDIT_DATA_ATTRIBUTE_IDX ON AUDIT_DATA (ATTRIBUTE)  ALLOW REVERSE SCANS 
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON AUDIT_DATA TO IGA;
GRANT ALL ON AUDIT_DATA TO IGACONN;
GRANT SELECT ON AUDIT_DATA TO REP;


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat :=
'CREATE SEQUENCE AUDIT_DATA_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    CACHE 1000
    NO CYCLE
    NO ORDER
    ';	

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE AUDIT_DATA' );

GRANT USAGE ON SEQUENCE AUDIT_DATA_SEQ TO IGA;
GRANT USAGE ON SEQUENCE AUDIT_DATA_SEQ TO IGACONN;
GRANT SELECT ON SEQUENCE AUDIT_DATA_SEQ TO REP;
