 declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42703'); -- column not defined

begin
  stat := '
  ALTER TABLE IB_RE_GROUPS
    DROP COLUMN DISPLAY_NAME_LOWER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('REORG TABLE IB_RE_GROUPS');


 declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42703'); -- column not defined

begin
  stat := '
  ALTER TABLE IB_RE_USERS
    DROP COLUMN USER_NAME_LOWER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('REORG TABLE IB_RE_USERS');

-- END OF DROP COLUMNS


declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42509'); -- operation not allowed because of dynamic rules

begin
  stat :='SET INTEGRITY FOR IB_RE_GROUPS OFF CASCADE IMMEDIATE TO FOREIGN KEY TABLES';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
   ALTER TABLE IB_RE_GROUPS 
	ADD DISPLAY_NAME_LOWER VARCHAR(1024 OCTETS)  
	GENERATED ALWAYS AS (LCASE(DISPLAY_NAME,''tr_TR'',1024))
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'51027'); -- table not in pending integrity state

begin
  stat :='SET INTEGRITY FOR IB_RE_GROUPS IMMEDIATE CHECKED FORCE GENERATED';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('REORG TABLE IB_RE_GROUPS');

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'51027'); -- table not in pending integrity state

begin
  stat :='SET INTEGRITY FOR IB_RE_GROUP_MEMBERS IMMEDIATE CHECKED';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/




declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42509'); -- operation not allowed because of dynamic rules

begin
  stat :='SET INTEGRITY FOR IB_RE_USERS OFF CASCADE IMMEDIATE TO FOREIGN KEY TABLES';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
   ALTER TABLE IB_RE_USERS 
	ADD USER_NAME_LOWER VARCHAR(256 OCTETS)  
	GENERATED ALWAYS AS (LCASE(USER_NAME,''tr_TR'',256))
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'51027'); -- table not in pending integrity state

begin
  stat :='SET INTEGRITY FOR IB_RE_USERS IMMEDIATE CHECKED FORCE GENERATED';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('REORG TABLE IB_RE_USERS');

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'51027'); -- table not in pending integrity state

begin
  stat :='SET INTEGRITY FOR IB_RE_USER_ATTRS IMMEDIATE CHECKED';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX GROUP_TAR_DISP_NAME_LOWER_IDX ON IB_RE_GROUPS 
  (TARGET_ID, DISPLAY_NAME_LOWER)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('RUNSTATS ON TABLE IB_RE_GROUPS AND INDEX ALL');

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE INDEX IB_X_RE_USERS_USER_NAME ON IB_RE_USERS 
  (TARGET_ID, USER_NAME_LOWER)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD('RUNSTATS ON TABLE IB_RE_USERS AND INDEX ALL');
