declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE EMPLOYMENT_REVIEW_PWDMAN
(
  	ID 								NUMBER(16) 		NOT NULL,
	EMPLOYMENT_REVIEW 				NUMBER(16) 		NOT NULL,
	PWDMANAGEMENT 					NUMBER(16),
	PWDMANAGEMENT_CODE 				VARCHAR2(256),
	PWDMANAGEMENT_IS_DEFAULT 		NUMBER(1),
	PWDMANAGEMENT_DISABLED 			NUMBER(1) 		DEFAULT 0,
	PWDCFG 							NUMBER(16),
	PWDCFG_NAME 					VARCHAR2(256),
	PWDCFG_DESCRIPTION 				VARCHAR2(256),
	PWDCFG_STATE 					NUMBER(16) 		DEFAULT 0,
	PWDCFG_SYNC 					NUMBER(1),
	ATTR1 							VARCHAR2(256),
	ATTR2 							VARCHAR2(256),
	ATTR3 							VARCHAR2(256),
	ATTR4 							VARCHAR2(256),
	ATTR5 							VARCHAR2(256),
	ATTR6 							VARCHAR2(256),
	ATTR7 							VARCHAR2(256),
	ATTR8 							VARCHAR2(256),
	ATTR9 							VARCHAR2(256),
	ATTR10 							VARCHAR2(256)
 
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN
    ADD CONSTRAINT EMPLOYMENT_REV_PWDMAN_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
 ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN ADD (
  CONSTRAINT EMP_REV_PWDM_EMP_REV_FK
 FOREIGN KEY (EMPLOYMENT_REVIEW)
 REFERENCES EMPLOYMENT_REVIEW (ID)
    ON DELETE CASCADE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
 ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN ADD (
  CONSTRAINT EMP_REV_PWDM_PWDCFG_FK
 FOREIGN KEY (PWDCFG)
 REFERENCES PWDCFG (ID)
    ON DELETE SET NULL)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
 ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN ADD (
  CONSTRAINT EMP_REV_PWDM_PWDMANAGEMENT_FK
 FOREIGN KEY (PWDMANAGEMENT)
 REFERENCES PWDMANAGEMENT (ID)
    ON DELETE SET NULL)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX EMP_REV_PWDMAN_EMPREV_IDX ON EMPLOYMENT_REVIEW_PWDMAN
  (EMPLOYMENT_REVIEW)
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN TO IDEAS;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN TO IDEAS_CONNECTOR;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN TO IDEAS_REPORT;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN TO AA;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_SEQ TO IDEAS;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN_SEQ TO IDEAS_REPORT;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN_SEQ TO AA;

