--Oracle
declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE DATA_TRANSFORMATION_MAPPING
(
  TYPE                VARCHAR2(256),
  IN_VALUE            VARCHAR2(4000),
  OUT_VALUE           VARCHAR2(4000)
)
TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
CREATE INDEX DTM_TYPE_INVALUE_IDX ON DATA_TRANSFORMATION_MAPPING 
(TYPE,IN_VALUE)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
';


  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
CREATE INDEX DTM_TYPE_OUTVALUE_IDX ON DATA_TRANSFORMATION_MAPPING 
(TYPE,OUT_VALUE)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
';


  execute immediate (stat);

exception
  when exception1 then null;

end;
/