CREATE OR REPLACE TRIGGER TRG_ATTESTATION
  BEFORE INSERT OR UPDATE ON ATTESTATION
  FOR EACH ROW
begin
  if (inserting) then
    :new.close_date := to_date(to_char(:new.end_date, 'DD/MM/YYYY'), 'DD/MM/YYYY');
  elsif (updating) then
    if ((:new.state = 4 and :old.state <> 4) OR :new.state = 5) then
      :new.close_date := to_date(to_char(sysdate, 'DD/MM/YYYY'), 'DD/MM/YYYY');
    else
      :new.close_date := to_date(to_char(:new.end_date, 'DD/MM/YYYY'), 'DD/MM/YYYY');
    end if;
  end if;
end TRG_ATTESTATION;
/


