declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE EXCEPTION_STATUS_MAP
(
	ID 								NUMBER(16) 	    	NOT NULL,
	ENTITY							NUMBER(16),
	EXCEPTION		 				VARCHAR2(256),
	STATUS_KEY 						VARCHAR2(256)
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE EXCEPTION_STATUS_MAP
    ADD CONSTRAINT EXCEPTION_STATUS_MAP_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON EXCEPTION_STATUS_MAP TO IDEAS;
GRANT ALL ON EXCEPTION_STATUS_MAP TO IDEAS_CONNECTOR;
GRANT SELECT ON EXCEPTION_STATUS_MAP TO IDEAS_REPORT;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE EXCEPTION_STATUS_MAP_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EXCEPTION_STATUS_MAP_SEQ TO IDEAS;
GRANT ALL ON EXCEPTION_STATUS_MAP_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON EXCEPTION_STATUS_MAP_SEQ TO IDEAS_REPORT;

