CREATE OR REPLACE function rep_ent_detail
(
  ran_code in varchar2
)
return number is
  cur             sys_refcursor;
  entitlement_id  number(16);
begin
  open cur for
    select distinct e.id from entitlement e
    where e.authorized > 0
    and e.int_type > 1;
  loop
    fetch cur into entitlement_id;
    exit when cur%NOTFOUND;

    insert into tmp_report_entitlement ( id, parent_id, child_id, child_level, child_level_num, random_code )
    select tmp_report_entitlement_seq.nextval, entitlement_id, entitlement_id, '', null, ran_code from dual;

    insert into tmp_report_entitlement ( id, parent_id, child_id, child_level, child_level_num, random_code )
    select tmp_report_entitlement_seq.nextval, entitlement_id, t.child, rpad ( ' ', 4*level, ' ' ), level, ran_code from
    /*PG-BEGIN*/
    entitlement_hier t
    connect by prior t.child = t.parent
    start with t.parent = entitlement_id;
    /*( select * from connectby ( 'entitlement_hier',  'child', 'parent', cast ( entitlement_id as varchar ), 0 )
      as t ( child numeric(16), parent numeric(16), level int ) ) t;*/
    /*PG-END*/
  end loop;
  close cur;

  return 0;
end rep_ent_detail;
/
