-----------------------------------------------------------
-- COMMON VALUES                                         --
-----------------------------------------------------------

DEFINE IDEAS_VERSION = 'IGI V5.2.6.2.IF2'
DEFINE IDEAS_LOG = 'IGI_V5_2_6_2.IF2.log'
DEFINE IDEAS_DB_SID = &_CONNECT_IDENTIFIER

-----------------------------------------------------------
-- DEFAULT PASS VALUES                                   --
-----------------------------------------------------------

--DEFINE IDEAS_SCHEMA_DEF_PASS = '"ideas"'

-----------------------------------------------------------
-- DB ROLES                                              --
-----------------------------------------------------------

DEFINE IDEAS_ROLE_NAME = 'IDEAS_ROLE'

-- Below file paths are no longer used (so no need to fix them)

-----------------------------------------------------------
-- RECONNECTION SCRIPTS                                  --
-----------------------------------------------------------

DEFINE CHECK_USER = 'IGI_INSTALLATION/00-COMMON/Connect/01-check_current_user.sql'
DEFINE RECONNECT = 'IGI_INSTALLATION/00-COMMON/Connect/02-reconnect.sql'
DEFINE RECONNECT_BLANK = 'IGI_INSTALLATION/00-COMMON/Connect/02-reconnect_blank.sql'

-----------------------------------------------------------
-- UNATTENDED QUESTION SCRIPTS                           --
-----------------------------------------------------------

DEFINE TBLS_PATH = 'IGI_INSTALLATION/00-COMMON/01-COMMON_TBLS.sql'
DEFINE TBLS_PATH_BLANK = 'IGI_INSTALLATION/00-COMMON/01-COMMON_TBLS_blank.sql'

DEFINE TBLS_SIZE = 'IGI_INSTALLATION/00-COMMON/09-TBLS_SIZE.sql'
DEFINE TBLS_SIZE_BLANK = 'IGI_INSTALLATION/00-COMMON/09-TBLS_SIZE_blank.sql'

-----------------------------------------------------------
-- DB TABLESPACE NAMES                                   --
-----------------------------------------------------------

--IGA Core TABLESPACE
--CONNECTOR TABLESPACE
--EMAIL SERVICE TABLESPACE
--SWIM TABLESPACE
DEFINE IGA_CORE_TBLS_DATA = 'IGA_CORE_DATA'
DEFINE IGA_CORE_TBLS_DATA_S = '8'
DEFINE IGA_CORE_TBLS_DATA_M = '256'
DEFINE IGA_CORE_TBLS_DATA_L = '512'

DEFINE IGA_CORE_TBLS_INDX = 'IGA_CORE_INDX'
DEFINE IGA_CORE_TBLS_INDX_S = '16'
DEFINE IGA_CORE_TBLS_INDX_M = '512'
DEFINE IGA_CORE_TBLS_INDX_L = '1024'

DEFINE IGA_CORE_TBLS_BLOB = 'IGA_CORE_BLOB'
DEFINE IGA_CORE_TBLS_BLOB_S = '8'
DEFINE IGA_CORE_TBLS_BLOB_M = '64'
DEFINE IGA_CORE_TBLS_BLOB_L = '128'

DEFINE IGA_CORE_TBLS_TEMP = 'IGA_CORE_TEMP'
DEFINE IGA_CORE_TBLS_TEMP_S = '256'
DEFINE IGA_CORE_TBLS_TEMP_M = '512'
DEFINE IGA_CORE_TBLS_TEMP_L = '1024'

--REPORT TABLESPACE
DEFINE IGA_REPORT_TBLS_DATA = 'IGA_REPORT_DATA'
DEFINE IGA_REPORT_TBLS_DATA_S = '8'
DEFINE IGA_REPORT_TBLS_DATA_M = '32'
DEFINE IGA_REPORT_TBLS_DATA_L = '64'

DEFINE IGA_REPORT_TBLS_INDX = 'IGA_REPORT_INDX'
DEFINE IGA_REPORT_TBLS_INDX_S = '16'
DEFINE IGA_REPORT_TBLS_INDX_M = '64'
DEFINE IGA_REPORT_TBLS_INDX_L = '128'

DEFINE IGA_REPORT_TBLS_BLOB = 'IGA_REPORT_BLOB'
DEFINE IGA_REPORT_TBLS_BLOB_S = '8'
DEFINE IGA_REPORT_TBLS_BLOB_M = '16'
DEFINE IGA_REPORT_TBLS_BLOB_L = '32'

DEFINE IGA_REPORT_TBLS_TEMP = 'IGA_REPORT_TEMP'
DEFINE IGA_REPORT_TBLS_TEMP_S = '256'
DEFINE IGA_REPORT_TBLS_TEMP_M = '512'
DEFINE IGA_REPORT_TBLS_TEMP_L = '1024'

--DESK TABLESPACE
--IDEAS ACCOUNT TABLESPACE
--SCHEDULER TABLESPACE
DEFINE IGA_SERVICE_TBLS_DATA = 'IGA_SERVICE_DATA'
DEFINE IGA_SERVICE_TBLS_DATA_S = '8'
DEFINE IGA_SERVICE_TBLS_DATA_M = '32'
DEFINE IGA_SERVICE_TBLS_DATA_L = '64'

DEFINE IGA_SERVICE_TBLS_INDX = 'IGA_SERVICE_INDX'
DEFINE IGA_SERVICE_TBLS_INDX_S = '16'
DEFINE IGA_SERVICE_TBLS_INDX_M = '64'
DEFINE IGA_SERVICE_TBLS_INDX_L = '128'

DEFINE IGA_SERVICE_TBLS_BLOB = 'IGA_SERVICE_BLOB'
DEFINE IGA_SERVICE_TBLS_BLOB_S = '8'
DEFINE IGA_SERVICE_TBLS_BLOB_M = '16'
DEFINE IGA_SERVICE_TBLS_BLOB_L = '32'

DEFINE IGA_SERVICE_TBLS_TEMP = 'IGA_SERVICE_TEMP'
DEFINE IGA_SERVICE_TBLS_TEMP_S = '256'
DEFINE IGA_SERVICE_TBLS_TEMP_M = '512'
DEFINE IGA_SERVICE_TBLS_TEMP_L = '1024'

--ACCESS ANALITYCS TABLESPACE
DEFINE AA_TBLS_DATA = 'AA_DATA'
DEFINE AA_TBLS_DATA_S = '8'
DEFINE AA_TBLS_DATA_M = '32'
DEFINE AA_TBLS_DATA_L = '64'

DEFINE AA_TBLS_INDX = 'AA_INDX'
DEFINE AA_TBLS_INDX_S = '16'
DEFINE AA_TBLS_INDX_M = '64'
DEFINE AA_TBLS_INDX_L = '128'

DEFINE AA_TBLS_BLOB = 'AA_BLOB'
DEFINE AA_TBLS_BLOB_S = '8'
DEFINE AA_TBLS_BLOB_M = '16'
DEFINE AA_TBLS_BLOB_L = '32'

DEFINE AA_TBLS_TEMP = 'AA_TEMP'
DEFINE AA_TBLS_TEMP_S = '256'
DEFINE AA_TBLS_TEMP_M = '512'
DEFINE AA_TBLS_TEMP_L = '1024'

--CCS TABLESPACE
DEFINE CCS_TBLS_DATA = 'CCS_DATA'
DEFINE CCS_TBLS_DATA_S = '8'
DEFINE CCS_TBLS_DATA_M = '1024'
DEFINE CCS_TBLS_DATA_L = '2048'

DEFINE CCS_TBLS_INDX = 'CCS_INDX'
DEFINE CCS_TBLS_INDX_S = '16'
DEFINE CCS_TBLS_INDX_M = '1536'
DEFINE CCS_TBLS_INDX_L = '3072'

DEFINE CCS_TBLS_BLOB = 'CCS_BLOB'
DEFINE CCS_TBLS_BLOB_S = '8'
DEFINE CCS_TBLS_BLOB_M = '128'
DEFINE CCS_TBLS_BLOB_L = '256'

DEFINE CCS_TBLS_TEMP = 'CCS_TEMP'
DEFINE CCS_TBLS_TEMP_S = '256'
DEFINE CCS_TBLS_TEMP_M = '512'
DEFINE CCS_TBLS_TEMP_L = '1024'

--ILC IB TABLESPACE
DEFINE ILC_IB_TBLS_DATA = 'ILC_IB_DATA'
DEFINE ILC_IB_TBLS_DATA_S = '8'
DEFINE ILC_IB_TBLS_DATA_M = '32'
DEFINE ILC_IB_TBLS_DATA_L = '64'

DEFINE ILC_IB_TBLS_INDX = 'ILC_IB_INDX'
DEFINE ILC_IB_TBLS_INDX_S = '16'
DEFINE ILC_IB_TBLS_INDX_M = '64'
DEFINE ILC_IB_TBLS_INDX_L = '128'

DEFINE ILC_IB_TBLS_BLOB = 'ILC_IB_BLOB'
DEFINE ILC_IB_TBLS_BLOB_S = '8'
DEFINE ILC_IB_TBLS_BLOB_M = '16'
DEFINE ILC_IB_TBLS_BLOB_L = '32'

DEFINE ILC_IB_TBLS_TEMP = 'ILC_IB_TEMP'
DEFINE ILC_IB_TBLS_TEMP_S = '256'
DEFINE ILC_IB_TBLS_TEMP_M = '512'
DEFINE ILC_IB_TBLS_TEMP_L = '1024'

--DEFRAG TABLESPACE
DEFINE DEFRAG_TBLS = 'DEFRAG'
DEFINE DEFRAG_TBLS_SIZE = '16'

--DEFAULT COMMON TABLESPACE
DEFINE IDEAS_TBLS_TEMP = 'IDEAS_TEMP'
DEFINE IDEAS_TBLS_TEMP_SIZE = '1024'

-----------------------------------------------------------
-- DB SCHEMA NAMES - SUPER ADMINISTRATORS                --
-----------------------------------------------------------

--SUPER ADMIN USERS
DEFINE IDEAS_SUPER_ADMIN_USER = 'IDEAS'
DEFINE IDEAS_SUPER_ADMIN_PASS = 'ideas'

DEFINE IDEAS_CONN_SUPER_ADMIN_USER = 'IDEAS_CONNECTOR'
DEFINE IDEAS_CONN_SUPER_ADMIN_PASS = 'ideas_connector'

DEFINE IDEAS_REPORT_SUPER_ADMIN_USER = 'IDEAS_REPORT'
DEFINE IDEAS_REPORT_SUPER_ADMIN_PASS = 'ideas_report'

DEFINE AA_SUPER_ADMIN_USER = 'AA'
DEFINE AA_SUPER_ADMIN_PASS = 'aa'

-----------------------------------------------------------
-- DB SCHEMA NAMES - MAIN USERS                          --
-----------------------------------------------------------

--IGA Core ADMIN MAIN USERS
DEFINE IGA_ADMIN_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_PASS = 'iga_admin'

--OTHER ADMIN USERS
DEFINE IGA_REPORT_ADMIN_USER = 'IGA_REPORT_ADMIN'
DEFINE IGA_REPORT_ADMIN_PASS = 'iga_report_admin'

DEFINE AA_ADMIN_USER = 'AA_ADMIN'
DEFINE AA_ADMIN_PASS = 'aa_admin'

--IGA Core REALM MAIN USERS
DEFINE IGA_CORE_USER = 'IGA_CORE'
DEFINE IGA_CORE_PASS = 'iga_core'

DEFINE IGA_REPORT_CORE_USER = 'IGA_REPORT_CORE'
DEFINE IGA_REPORT_CORE_PASS = 'iga_report_core'

DEFINE AA_CORE_USER = 'AA_CORE'
DEFINE AA_CORE_PASS = 'aa_core'

--SCHEDULER USER
--IDEAS ACCOUNT USER
--DESK USER
DEFINE IGA_SERVICE_USER = 'IGA_SERVICE'
DEFINE IGA_SERVICE_PASS = 'iga_service'

--IGA QUARTZ
DEFINE IGA_QUARTZ_USER = 'IGA_QUARTZ'
DEFINE IGA_QUARTZ_PASS = 'iga_quartz'

--SIB
DEFINE SIB_USER = 'ITIML000'
DEFINE SIB_PASS = 'itiml000'

--IB
DEFINE IB_USER = 'ITIMUSER'
DEFINE IB_PASS = 'itimuser'

--IGA Core CCS MAIN USERS
DEFINE IGA_CCS_USER = 'CCS_CORE'
DEFINE IGA_CCS_PASS = 'ccs_core'

--Schema not defined for ADMIN
DEFINE ADMIN_NOT_DEFINED = 'ADMIN_NOT_DEFINED'


-----------------------------------------------------------
-- PARAMETERS                                            --
-----------------------------------------------------------

--IGA Core ADMIN PARAMETERS
DEFINE IGA_ADMIN_NAME = 'Admin'
DEFINE IGA_ADMIN_DESC = 'Admin Realm'
DEFINE IGA_ADMIN_OU_ROOT = 'root'
DEFINE IGA_ADMIN_TASK_ROOT = 'root'

--IGA Core REALM PARAMETERS
DEFINE IGA_CORE_NAME = 'Ideas'
DEFINE IGA_CORE_DESC = 'Ideas Realm'
DEFINE IGA_CORE_OU_ROOT = 'root'
DEFINE IGA_CORE_TASK_ROOT = 'root'

--CCS REALM PARAMETERS
DEFINE IGA_CCS_NAME = 'Ideas_ARC4SAP'
DEFINE IGA_CCS_DESC = 'Ideas ARC4SAP Realm'
DEFINE IGA_CCS_OU_ROOT = 'root'
DEFINE IGA_CCS_TASK_ROOT = 'root'

-----------------------------------------------------------
-- ADMINISTRATOR SCRIPT VALUES                           --
-----------------------------------------------------------

--IGA Core ADMIN USER
DEFINE IGA_ADMIN_SUPER_USER = 'sysadmin'

DEFINE IGA_ADMIN_SUPER_USER_SERV = 'userapplication'

DEFINE IGA_CORE_SUPER_USER = 'admin'

DEFINE IGA_ADMINISTRATOR_ADMIN = 'IGA&IGA_ADMIN_NAME'
DEFINE IGA_ADMINISTRATOR_CORE = 'IGA&IGA_CORE_NAME'

-----------------------------------------------------------
-- DEFAULT SCRIPT VALUES                                 --
-----------------------------------------------------------

DEFINE IGA_SPLIT_ADMIN = 'NO'
DEFINE IGA_SPLIT_CORE = 'NO'

DEFINE IDEAS_COMMON_TEMP = 'N'
DEFINE CUSTOMER_SUFFIX = 'CORE'

-----------------------------------------------------------
-- DEFAULT PASS VALUES FOR ALL SCHEMAS                   --
-----------------------------------------------------------
--SUPER ADMIN PASS
DEFINE IDEAS_SUPER_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IDEAS_CONN_SUPER_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IDEAS_REPORT_SUPER_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE AA_SUPER_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IGA Core ADMIN MAIN USERS
DEFINE IGA_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--OTHER ADMIN USERS
DEFINE IGA_REPORT_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'

DEFINE AA_ADMIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IGA Core REALM MAIN USERS
DEFINE IGA_CORE_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--OTHER REALM USERS
DEFINE IGA_REPORT_CORE_PASS = '&IDEAS_SCHEMA_DEF_PASS'

DEFINE AA_CORE_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--DESK PASS
--IDEAS ACCOUNT PASS
--SCHEDULER PASS
DEFINE IGA_SERVICE_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--SCHEDULER QUARTZ PASS
DEFINE IGA_QUARTZ_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--SIB PASS
DEFINE SIB_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IB PASS
DEFINE IB_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IGA Core CCS MAIN USERS
DEFINE IGA_CCS_PASS = '&IDEAS_SCHEMA_DEF_PASS'

-----------------------------------------------------------
-- DB SCHEMA NAMES - SPLIT USERS                         --
-----------------------------------------------------------

--IGA Core ADMIN OTHER USERS
DEFINE IGA_ADMIN_MAIN_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_MAIN_PASS = 'iga_admin'

DEFINE IGA_ADMIN_AC_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_AC_PASS = 'iga_admin'

DEFINE IGA_ADMIN_ARC_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_ARC_PASS = 'iga_admin'

DEFINE IGA_ADMIN_ARM_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_ARM_PASS = 'iga_admin'

DEFINE IGA_ADMIN_EC_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_EC_PASS = 'iga_admin'

DEFINE IGA_ADMIN_ES_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_ES_PASS = 'iga_admin'

DEFINE IGA_ADMIN_ILC_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_ILC_PASS = 'iga_admin'

DEFINE IGA_ADMIN_IM_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_IM_PASS = 'iga_admin'

DEFINE IGA_ADMIN_JOB_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_JOB_PASS = 'iga_admin'

DEFINE IGA_ADMIN_LOC_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_LOC_PASS = 'iga_admin'

DEFINE IGA_ADMIN_RE_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_RE_PASS = 'iga_admin'

DEFINE IGA_ADMIN_RU_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_RU_PASS = 'iga_admin'

DEFINE IGA_ADMIN_ARC4S_USER = 'IGA_ADMIN'
DEFINE IGA_ADMIN_ARC4S_PASS = 'iga_admin'

--IGA Core REALM OTHER USERS
DEFINE IGA_CORE_MAIN_USER = 'IGA_CORE'
DEFINE IGA_CORE_MAIN_PASS = 'iga_core'

DEFINE IGA_CORE_AC_USER = 'IGA_CORE'
DEFINE IGA_CORE_AC_PASS = 'iga_core'

DEFINE IGA_CORE_ARC_USER = 'IGA_CORE'
DEFINE IGA_CORE_ARC_PASS = 'iga_core'

DEFINE IGA_CORE_ARM_USER = 'IGA_CORE'
DEFINE IGA_CORE_ARM_PASS = 'iga_core'

DEFINE IGA_CORE_EC_USER = 'IGA_CORE'
DEFINE IGA_CORE_EC_PASS = 'iga_core'

DEFINE IGA_CORE_ES_USER = 'IGA_CORE'
DEFINE IGA_CORE_ES_PASS = 'iga_core'

DEFINE IGA_CORE_ILC_USER = 'IGA_CORE'
DEFINE IGA_CORE_ILC_PASS = 'iga_core'

DEFINE IGA_CORE_IM_USER = 'IGA_CORE'
DEFINE IGA_CORE_IM_PASS = 'iga_core'

DEFINE IGA_CORE_JOB_USER = 'IGA_CORE'
DEFINE IGA_CORE_JOB_PASS = 'iga_core'

DEFINE IGA_CORE_LOC_USER = 'IGA_CORE'
DEFINE IGA_CORE_LOC_PASS = 'iga_core'

DEFINE IGA_CORE_RE_USER = 'IGA_CORE'
DEFINE IGA_CORE_RE_PASS = 'iga_core'

DEFINE IGA_CORE_RU_USER = 'IGA_CORE'
DEFINE IGA_CORE_RU_PASS = 'iga_core'

DEFINE IGA_CORE_ARC4S_USER = 'IGA_ADMIN'
DEFINE IGA_CORE_ARC4S_PASS = 'iga_core'

--IGA Core CCS OTHER USERS
DEFINE IGA_CCS_MAIN_USER = 'CCS_CORE'
DEFINE IGA_CCS_MAIN_PASS = 'ccs_core'

DEFINE IGA_CCS_AC_USER = 'CCS_CORE'
DEFINE IGA_CCS_AC_PASS = 'ccs_core'

DEFINE IGA_CCS_ARC_USER = 'CCS_CORE'
DEFINE IGA_CCS_ARC_PASS = 'ccs_core'

DEFINE IGA_CCS_ARM_USER = 'CCS_CORE'
DEFINE IGA_CCS_ARM_PASS = 'ccs_core'

DEFINE IGA_CCS_EC_USER = 'CCS_CORE'
DEFINE IGA_CCS_EC_PASS = 'ccs_core'

DEFINE IGA_CCS_ES_USER = 'CCS_CORE'
DEFINE IGA_CCS_ES_PASS = 'ccs_core'

DEFINE IGA_CCS_ILC_USER = 'CCS_CORE'
DEFINE IGA_CCS_ILC_PASS = 'ccs_core'

DEFINE IGA_CCS_IM_USER = 'CCS_CORE'
DEFINE IGA_CCS_IM_PASS = 'ccs_core'

DEFINE IGA_CCS_JOB_USER = 'CCS_CORE'
DEFINE IGA_CCS_JOB_PASS = 'ccs_core'

DEFINE IGA_CCS_LOC_USER = 'CCS_CORE'
DEFINE IGA_CCS_LOC_PASS = 'ccs_core'

DEFINE IGA_CCS_RE_USER = 'CCS_CORE'
DEFINE IGA_CCS_RE_PASS = 'ccs_core'

DEFINE IGA_CCS_RU_USER = 'CCS_CORE'
DEFINE IGA_CCS_RU_PASS = 'ccs_core'

DEFINE IGA_CCS_ARC4S_USER = 'CCS_CORE'
DEFINE IGA_CCS_ARC4S_PASS = 'ccs_core'

--IGA Core ADMIN OTHER USERS
DEFINE IGA_ADMIN_MAIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_AC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_ARC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_ARM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_EC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_ES_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_ILC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_IM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_JOB_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_LOC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_RE_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_RU_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_ADMIN_ARC4S_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IGA Core REALM OTHER USERS
DEFINE IGA_CORE_MAIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_AC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_ARC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_ARM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_EC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_ES_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_ILC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_IM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_JOB_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_LOC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_RE_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_RU_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CORE_ARC4S_PASS = '&IDEAS_SCHEMA_DEF_PASS'

--IGA Core CCS OTHER USERS
DEFINE IGA_CCS_MAIN_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_AC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_ARC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_ARM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_EC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_ES_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_ILC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_IM_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_JOB_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_LOC_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_RE_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_RU_PASS = '&IDEAS_SCHEMA_DEF_PASS'
DEFINE IGA_CCS_ARC4S_PASS = '&IDEAS_SCHEMA_DEF_PASS'
