declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE IB_RE_GROUP_MEMBER_CACHE (
	TARGET_ID 	VARCHAR(256) 	NOT NULL,
	OBJECT_TYPE VARCHAR(256),
	SERIALIZED_OBJECT BLOB
  )
  LOB (SERIALIZED_OBJECT) STORE AS
    (
      TABLESPACE   &LOB_TABLESPACE
      ENABLE       STORAGE IN ROW
      CHUNK        8192
      NOCACHE
      INDEX IRGMC_SERIAL_OBJECT_OBJ_IDX
      (
        TABLESPACE &LOB_TABLESPACE
      )
    )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

commit;
/


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX GMCACHE_TARGET_ID_IDX ON IB_RE_GROUP_MEMBER_CACHE 
  (TARGET_ID)
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON IB_RE_GROUP_MEMBER_CACHE TO ITIMUSER;
GRANT SELECT ON IB_RE_GROUP_MEMBER_CACHE TO IDEAS_REPORT;
