CREATE OR REPLACE TRIGGER TRG_ADD_REMOVE_ENT_FLAT_HIER
  AFTER INSERT ON ENTITLEMENT_FLAT_HIER
  FOR EACH ROW
DECLARE
  ent_profile_type       constant number(1) := 1;
  ent_brole_type         constant number(1) := 3;
  code_oper              varchar2(256);
  tmp_code_oper          varchar2(256);
  v_tar_sync             number(16);
  v_app_sync_dis         number(1);
  v_acc_cfg				 number(16);
  v_id_acc			     number(16);
  v_code_acc             varchar2(128);
  v_person 				 number(16); 
  v_ent_parent           number(16); 
  v_id_emp               number(16);
  cur_tmp				 sys_refcursor;

  counter                number(16);
begin
  select count(1) into counter from tmp_codoperation;
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE' );
  elsif ( counter = 1 ) then
    select code into tmp_code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE' );
  end if;

  -- add profile
  if ( inserting ) then
    if ( :new.child_int_type = ent_profile_type and :new.ext_fulfillment_limit = 0 ) then
      select p.sync, a.sync_disable, p.id into v_tar_sync, v_app_sync_dis, v_acc_cfg
      from application a, target t, pwdcfg p
      where t.id = a.target and a.id = :new.child_application
      and t.pwdcfg = p.id;
    
      -- verifico se l'applicazione e propagabile
      if ( ( v_tar_sync is null or v_tar_sync = 0 ) or v_app_sync_dis <> 0 ) then
        return;
      end if;
    
      -- direct assignments
      open cur_tmp for
      
      		select e.person, e.entitlement, e.id
      	      from employment e
	          where e.entitlement = :new.parent and 
	        		e.represented is null;
	  
	  loop
	    
	  fetch cur_tmp into v_person, v_ent_parent, v_id_emp;
	 	exit when cur_tmp%NOTFOUND;
      
        v_id_acc := null;
        v_code_acc := null;
      
        code_oper := tmp_code_oper;
      
        select count(1)
          into counter
          from employment_pwdmanagement ep, pwdmanagement p
         where ep.employment = v_id_emp
           and ep.pwdmanagement = p.id
           and p.pwdcfg = v_acc_cfg;
      
        if (counter = 1) then
          select distinct p.id, p.code
            into v_id_acc, v_code_acc
            from employment_pwdmanagement ep, pwdmanagement p
           where ep.employment = v_id_emp
             and ep.pwdmanagement = p.id
             and p.pwdcfg = v_acc_cfg;
        end if;
      
        if (:new.parent_int_type = ent_brole_type and counter = 0) then
          select count(1)
            into counter
            from pwdmanagement p
           where -- univocita della terna garantita da codice
           p.person = v_person
           and p.pwdcfg = v_acc_cfg
           and p.is_default = 1;
        
          if (counter = 1) then
          
            select distinct p.id, p.code
              into v_id_acc, v_code_acc
              from pwdmanagement p
             where p.person = v_person
               and p.pwdcfg = v_acc_cfg
               and p.is_default = 1;
          
            -- employment_pwdmanagement
            select count(1)
              into counter
              from employment_pwdmanagement ep
             where ep.employment = v_id_emp
               and ep.pwdmanagement = v_id_acc;
          
            if (counter = 0) then
              insert into employment_pwdmanagement
                (id, employment, pwdmanagement, last_mod_user)
              values
                (employment_pwdmanagement_seq.nextval, v_id_emp, v_id_acc, 'TRG_ADD_REMOVE_ENT_FLAT_HIER');
            end if;
          end if;
        end if;
      
        if (v_id_acc is null and v_code_acc is null) then
          code_oper := 'TRG_ADD_REMOVE_ENT_FLAT_HIER'; -- need to insert a recognizable value for cod_operation field
        end if;
      
        insert into authorizations
          ( id, person, entitlement, profile, cod_operation, entitlement_flat_hier, employment, pwdmanagement, account_code )
        values
          ( authorizations_seq.nextval, v_person, v_ent_parent, :new.child, code_oper, :new.id, v_id_emp, v_id_acc, v_code_acc );
      
      end loop;
    
      close cur_tmp;
    
      -- delegation
      open cur_tmp for
        select e.person, e.entitlement, e.id
          from employment e
         where e.entitlement = :new.parent
           and e.represented is not null;
    
      loop
        fetch cur_tmp
          into v_person, v_ent_parent, v_id_emp;
      
        exit when cur_tmp % notfound;
      
        v_id_acc := null;
      
        v_code_acc := null;
      
        code_oper := tmp_code_oper;
      
        select count(1)
          into counter
          from employment_pwdmanagement ep, pwdmanagement p
         where ep.employment = v_id_emp
           and ep.pwdmanagement = p.id
           and p.pwdcfg = v_acc_cfg;
      
        if (counter = 1) then
          select distinct p.id, p.code
            into v_id_acc, v_code_acc
            from employment_pwdmanagement ep, pwdmanagement p
           where ep.employment = v_id_emp
             and ep.pwdmanagement = p.id
             and p.pwdcfg = v_acc_cfg;
        end if;
      
        if (:new.parent_int_type = ent_brole_type and counter = 0) then
          select count(1)
            into counter
            from pwdmanagement p
           where -- univocita della terna garantita da codice
           p.person = v_person
           and p.pwdcfg = v_acc_cfg
           and p.is_default = 1;
        
          if (counter = 1) then
          
            select distinct p.id, p.code
              into v_id_acc, v_code_acc
              from pwdmanagement p
             where p.person = v_person
               and p.pwdcfg = v_acc_cfg
               and p.is_default = 1;
          
            -- employment_pwdmanagement
            select count(1)
              into counter
              from employment_pwdmanagement ep
             where ep.employment = v_id_emp
               and ep.pwdmanagement = v_id_acc;
          
            if (counter = 0) then
              insert into employment_pwdmanagement
                (id, employment, pwdmanagement, last_mod_user)
              values
                (employment_pwdmanagement_seq.nextval,
                 v_id_emp,
                 v_id_acc,
                 'TRG_ADD_REMOVE_ENT_FLAT_HIER');
            end if;
          end if;
        end if;
      
        if (v_id_acc is null and v_code_acc is null) then
          code_oper := 'TRG_ADD_REMOVE_ENT_FLAT_HIER'; -- need to insert a recognizable value for cod_operation field
        end if;
      
        insert into authorizations
          ( id, person, entitlement, profile, cod_operation, entitlement_flat_hier, employment, pwdmanagement, account_code )
        values
          ( authorizations_seq.nextval, v_person, v_ent_parent, :new.child, code_oper, :new.id, v_id_emp, v_id_acc, v_code_acc);
      
      end loop;
    
      close cur_tmp;
    end if;
  end if;
end TRG_ADD_REMOVE_ENT_FLAT_HIER;
/
