CREATE OR REPLACE TRIGGER TRG_INS_EMPL_PWDMAN
  AFTER INSERT ON EMPLOYMENT_PWDMANAGEMENT
  FOR EACH ROW
declare
  cur_tmp        sys_refcursor;
  code_oper      varchar2(64);
  counter        number(16);
  v_state        number(16);
  v_parent       number(16);
  v_represented  number(16);

begin

  if ((:new.last_mod_user is not null) and
     (upper(:new.last_mod_user) = 'TRG_ADD_REMOVE_ENT_FLAT_HIER' or
     upper(:new.last_mod_user) = 'ALIGN_ENTITLEMENT_JOB')) then
    return;
  end if;

  select count(1) into counter from tmp_codoperation;

  if (counter = 0) then
    RAISE_APPLICATION_ERROR(-20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  
  elsif (counter = 1) then
    select code into code_oper from tmp_codoperation;
  
  elsif (counter > 1) then
    RAISE_APPLICATION_ERROR(-20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

  open cur_tmp for
    select e.state, e.parent, e.represented
      from employment e
     where e.id = :new.employment;

  fetch cur_tmp
    into v_state, v_parent, v_represented;

  close cur_tmp;

  if (v_state = 0) then
    --enabled
    if (v_parent is null) then
      --normal
      insert into authorizations
        (id,
         person,
         pwdmanagement,
         account_code,
         entitlement,
         profile,
         cod_operation,
         entitlement_flat_hier,
         employment)
        select authorizations_seq.nextval,
               e.person,
               pm.id,
               pm.code,
               e.entitlement,
               efh.child,
               code_oper,
               efh.id,
               e.id
          from application           a,
               target                t,
               pwdcfg                p,
               entitlement_flat_hier efh,
               employment            e,
               pwdmanagement         pm
         where t.id = a.target
           and a.id = efh.child_application
           and t.pwdcfg = p.id
           and pm.pwdcfg = p.id
           and e.id = :new.employment
           and pm.id = :new.pwdmanagement
           and efh.parent = e.entitlement
           and efh.child_int_type = 1
           and (p.sync is not null and p.sync <> 0)
           and a.sync_disable = 0
           and efh.ext_fulfillment_limit = 0;
    else
      --delegation
      insert into authorizations
        (id,
         person,
         pwdmanagement,
         account_code,
         entitlement,
         profile,
         cod_operation,
         represented,
         entitlement_flat_hier,
         employment)
        select authorizations_seq.nextval,
               e.person,
               pm.id,
               pm.code,
               e.entitlement,
               efh.child,
               code_oper,
               v_represented,
               efh.id,
               e.id
          from application           a,
               target                t,
               pwdcfg                p,
               entitlement_flat_hier efh,
               employment            e,
               pwdmanagement         pm
         where t.id = a.target
           and a.id = efh.child_application
           and t.pwdcfg = p.id
           and pm.pwdcfg = p.id
           and e.id = :new.employment
           and pm.id = :new.pwdmanagement
           and efh.parent = e.entitlement
           and efh.child_int_type = 1
           and (p.sync is not null and p.sync <> 0)
           and a.sync_disable = 0
           and efh.ext_fulfillment_limit = 0;
    end if;
  end if;
end TRG_INS_EMPL_PWDMAN;
/