declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE FIXED_ENTITY_SCOPE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  CACHE 1000
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON FIXED_ENTITY_SCOPE_SEQ TO IDEAS;
GRANT ALL ON FIXED_ENTITY_SCOPE_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON FIXED_ENTITY_SCOPE_SEQ TO IDEAS_REPORT;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ADD ID NUMBER(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ADD LOOKUP_SCOPE NUMBER(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

UPDATE FIXED_ENTITY_SCOPE SET ID = FIXED_ENTITY_SCOPE_SEQ.NEXTVAL WHERE ID IS NULL;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    MODIFY ( ID NOT NULL )
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_SCOPE
    ADD CONSTRAINT FES_ID_UK UNIQUE (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX FES_ID_IDX ON FIXED_ENTITY_SCOPE
  (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CREATE OR REPLACE TRIGGER TRG_FES_ID
  BEFORE INSERT OR UPDATE ON FIXED_ENTITY_SCOPE
  FOR EACH ROW
declare
begin
	if(:new.id is null) then 
	  :new.id := fixed_entity_scope_seq.nextval;
	end if;
return;
end TRG_FES_ID;

/
