declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE FIXED_ENTITY_LOOKUP_SCOPE
(
  	ID 								NUMBER(16) 		NOT NULL,
	FIXED_ENTITY	 				NUMBER(16) 		NOT NULL,
	OBJECT_ID						NUMBER(16),
	OBJECT_NAME		 				VARCHAR2(512),
	OBJECT_CODE		 				VARCHAR2(512),
	ATTR1 							VARCHAR2(256),
	ATTR2 							VARCHAR2(256),
	ATTR3 							VARCHAR2(256),
	ATTR4 							VARCHAR2(256),
	ATTR5 							VARCHAR2(256)
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE FIXED_ENTITY_LOOKUP_SCOPE
    ADD CONSTRAINT FIXED_ENTITY_LOOKUP_SCOPE_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
 ALTER TABLE FIXED_ENTITY_LOOKUP_SCOPE ADD (
  CONSTRAINT FELS_FIXED_ENTITY_FK
 FOREIGN KEY (FIXED_ENTITY)
 REFERENCES FIXED_ENTITY_SCOPE (ID)
    ON DELETE CASCADE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX FELS_FIXED_ENTITY_IDX ON FIXED_ENTITY_LOOKUP_SCOPE
  (FIXED_ENTITY)
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE TO IDEAS;
GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE TO IDEAS_CONNECTOR;
GRANT SELECT ON FIXED_ENTITY_LOOKUP_SCOPE TO IDEAS_REPORT;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE FIXED_ENTITY_LOOKUP_SCOPE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO IDEAS;
GRANT ALL ON FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON FIXED_ENTITY_LOOKUP_SCOPE_SEQ TO IDEAS_REPORT;

