declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE PERSON
    ADD FULLNAME VARCHAR2(1024)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE PERSON
    ADD FULLNAMEREV VARCHAR2(1024)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  cur          	sys_refcursor;
  
  p_id			number(16);
  p_name     	varchar2(256);
  p_surname     varchar2(256);
  
  counter 		number(16);

begin
  open cur for
    select p.id, p.name, p.surname from person p;
  
  counter := 0;
  
  loop
    fetch cur into p_id, p_name, p_surname;
    exit when cur%notfound;
	
    counter := counter + 1;
	
    IF((p_surname IS NULL OR p_surname='') AND (p_name IS NULL OR p_name=''))
	THEN
		update person p set fullname = null, fullnamerev = null where p.id = p_id;
	ELSIF(p_surname IS NULL OR p_surname='')
	THEN
		update person p set fullname = p_name, fullnamerev = p_name where p.id = p_id;
	ELSIF(p_name IS NULL OR p_name='')
	THEN
		update person p set fullname = p_surname, fullnamerev = p_surname where p.id = p_id;
	ELSE
		update person p set fullname = (p_name || ' ' || p_surname), fullnamerev = (p_surname || ' ' || p_name) where p.id = p_id;
	END IF;
	
   	if(counter = 10000) then 
   	    commit; 
   	    counter := 0;
   	end if;
   
  end loop;
  close cur;
  commit;
end;

/

CREATE OR REPLACE TRIGGER TRG_PERSON_FULLNAME
  BEFORE INSERT OR UPDATE ON PERSON
  FOR EACH ROW
declare
begin
  if((:new.surname IS NULL OR :new.surname='') AND (:new.name IS NULL OR :new.name=''))
  THEN
    :new.fullname := null;
    :new.fullnamerev := null;
    return;
  end if;
  
  if(:new.surname IS NULL OR :new.surname='')
  THEN
    :new.fullname := :new.name;
    :new.fullnamerev := :new.name;
    return;
  end if;
  
  if(:new.name IS NULL OR :new.name='')
  THEN
    :new.fullname := :new.surname;
    :new.fullnamerev := :new.surname;
    return;
  end if;
  
  :new.fullname := (:new.name || ' ' || :new.surname);
  :new.fullnamerev := (:new.surname || ' ' || :new.name);
return;
end TRG_PERSON_FULLNAME;
/
