declare
  cur_flow_type sys_refcursor;
  cur_flow_entity sys_refcursor;
  

  im_id         number(16);
  im_name       varchar(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';

  fevt_id       number(16);
  fevt_name     varchar2(256) := 'INTERNAL';
    
  fe_id         number(16);
  cfet_id       number(16);
  
  ft_id         number(16);
  
  f_id          number(16);
  f_name        varchar2(256) := 'SOD_STATUS_CHANGED';
  f_desc        varchar2(512) := '';

  counter       number(16);
  cfet_counter number(2) := 0;
  
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND');
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND');
  end if;
  
  select count(1) into counter from flow_type t;
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW TYPE FOUND');
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 0 ) then
   RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND');
  else
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 0 ) then
 	 RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND');
  ELSE if ( counter = 1 ) then
   select t.id into f_id from flow t 
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  end if;
 END IF;
  
  open cur_flow_type for
    select id from flow_type t;
  loop
    fetch cur_flow_type into ft_id;
    exit when cur_flow_type%NOTFOUND;
    cfet_counter := 0;
    select count(1) into counter from flow_entity t
  	where t.ideas_module = im_id and t.flow = f_id and flow_type = ft_id;
    IF ( counter = 0 ) then
     
    select flow_entity_seq.nextval into fe_id from dual;
    insert into flow_entity ( id, flow, flow_type, root, parent, flow_entity_type, position, creation_user, last_mod_user, ideas_module)
    values ( fe_id, f_id, ft_id, fe_id, null, 0, 0, '&IDEAS_VERSION', '&IDEAS_VERSION', im_id );
 	
   ELSE IF (counter > 1) THEN
   open cur_flow_entity for
    select id from flow_entity t WHERE t.ideas_module = im_id and t.flow = f_id and flow_type = ft_id ORDER BY t.id asc;
 	 loop
   		fetch cur_flow_entity into cfet_id;
    	exit when cur_flow_entity%NOTFOUND;
        cfet_counter := cfet_counter + 1;
        if(cfet_counter < counter) THEN 
	       DELETE FROM FLOW_ENTITY t WHERE t.id = cfet_id;
	    END IF;
 	  END LOOP;
 	 close cur_flow_entity;
 	 
 	END IF;
   END IF;
 
end loop;
close cur_flow_type;

end;
/
commit;
