declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE AUDIT_PROFILE
(
	ID 								NUMBER(16) 		NOT NULL,
	EVENT_ID						NUMBER(16),
	ENTITY							NUMBER(16),
	AUDIT_ENABLE					NUMBER(1)
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE AUDIT_PROFILE
    ADD CONSTRAINT AUDIT_PROFILE_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON AUDIT_PROFILE TO IDEAS;
GRANT ALL ON AUDIT_PROFILE TO IDEAS_CONNECTOR;
GRANT SELECT ON AUDIT_PROFILE TO IDEAS_REPORT;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE AUDIT_PROFILE_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON AUDIT_PROFILE_SEQ TO IDEAS;
GRANT ALL ON AUDIT_PROFILE_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON AUDIT_PROFILE_SEQ TO IDEAS_REPORT;

