declare
  stat        varchar2(4000);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE AUDIT_DATA
(
	ID 								NUMBER(16)		NOT NULL, 
	AUDIT_LOG 						NUMBER(16) 		NOT NULL, 
	OPERATOR 						VARCHAR2(256)	DEFAULT ''N/A'', 
	OPERATOR_ID 					VARCHAR2(128)	DEFAULT ''N/A'', 
	EVENT_ID 						NUMBER(16) 		NOT NULL, 
	EVENT 							VARCHAR2(256)	DEFAULT ''N/A'', 
	OPERATION_CODE 					VARCHAR2(256)	DEFAULT ''N/A'', 
	EVENT_DATE 						TIMESTAMP(6),
	BENEFICIARY_TYPE 				VARCHAR2(256)	DEFAULT ''N/A'', 
	BENEFICIARY_ID 					NUMBER(16)		DEFAULT 0, 
	BENEFICIARY 					VARCHAR2(256)	DEFAULT ''N/A'', 
	BENEFICIARY_ATTR1 				VARCHAR2(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR2 				VARCHAR2(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR3 				VARCHAR2(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR4 				VARCHAR2(256)	DEFAULT ''N/A'',
	BENEFICIARY_ATTR5 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_TYPE 					VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ID 					NUMBER(16)		DEFAULT 0,
	METADATA1 						VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ATTR1 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ATTR2 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ATTR3 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ATTR4 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA1_ATTR5 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_TYPE 					VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ID 					NUMBER(16) 		DEFAULT 0,
	METADATA2 						VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ATTR1 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ATTR2 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ATTR3 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ATTR4	 				VARCHAR2(256)	DEFAULT ''N/A'',
	METADATA2_ATTR5 				VARCHAR2(256)	DEFAULT ''N/A'',
	ATTRIBUTE						VARCHAR2(128)	DEFAULT ''N/A'',
	OLD_VALUE 						CLOB			DEFAULT ''N/A'',
	NEW_VALUE 						CLOB			DEFAULT ''N/A'',
	SOURCE_TYPE 					VARCHAR2(64)	DEFAULT ''N/A'',
	SOURCE_ID 						NUMBER(16)		DEFAULT 0, 
	SOURCE_NAME 					VARCHAR2(256)	DEFAULT ''N/A'',
	STATUS 							VARCHAR2(64)	DEFAULT ''N/A'',
	STATUS_REASON	 				CLOB			DEFAULT ''N/A'',
	ACTED_AS 						VARCHAR2(256)	DEFAULT ''N/A'',
	ACTED_AS_ID 					VARCHAR2(64)	DEFAULT ''N/A''
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE AUDIT_DATA
    ADD CONSTRAINT AUDIT_DATA_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX AUDIT_DATA_EVENTID_IDX ON AUDIT_DATA (EVENT_ID) REVERSE NOLOGGING NOPARALLEL TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX AUDIT_DATA_ATTRIBUTE_IDX ON AUDIT_DATA (ATTRIBUTE) REVERSE NOLOGGING NOPARALLEL TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON AUDIT_DATA TO IDEAS;
GRANT ALL ON AUDIT_DATA TO IDEAS_CONNECTOR;
GRANT SELECT ON AUDIT_DATA TO IDEAS_REPORT;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE AUDIT_DATA_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  CACHE 1000
  NOCYCLE
  ORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON AUDIT_DATA_SEQ TO IDEAS;
GRANT ALL ON AUDIT_DATA_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON AUDIT_DATA_SEQ TO IDEAS_REPORT;

