create or replace procedure del_indx(index_name in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-1418); -- index does not exist
begin
    execute immediate 'DROP INDEX ' || index_name;
exception
    when others then null;
end del_indx;
/

create or replace procedure create_indx(stat in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object
begin
    execute immediate (stat);
exception
    when exception1 then null;
end create_indx;
/

CALL del_indx('RM_UPL_ENT_KEY_IDX');

CALL create_indx('
CREATE UNIQUE INDEX RM_UPL_ENT_KEY_IDX ON RM_UPL_ENTITLEMENT
(APPLICATION, ENTITLEMENT_TYPE, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');


CALL del_indx('AA_UPL_ENT_KEY_IDX');

CALL create_indx('
CREATE UNIQUE INDEX AA_UPL_ENT_KEY_IDX ON AA_UPL_ENTITLEMENT
(APPLICATION, ENTITLEMENT_TYPE, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  
  
drop procedure del_indx;

drop procedure create_indx;

