create or replace procedure del_indx(index_name in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-1418); -- index does not exist
begin
    execute immediate 'DROP INDEX ' || index_name;
exception
    when others then null;
end del_indx;
/

create or replace procedure create_indx(stat in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object
begin
    execute immediate (stat);
exception
    when exception1 then null;
end create_indx;
/


CALL del_indx('AUTHOBJ_APP_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX AUTHOBJ_APP_LNAME_IDX ON AUTHOBJ
(APPLICATION, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
 

CALL del_indx('PROFILE_AO_FIELD_LNAME_ID_IDX');

CALL create_indx('
CREATE UNIQUE INDEX PROFILE_AO_FIELD_LNAME_ID_IDX ON PROFILE_AO_FIELD
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''), ID)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  

CALL del_indx('PROF_AO_F_VAL_LVALUE_ID_IDX');

CALL create_indx('
CREATE UNIQUE INDEX PROF_AO_F_VAL_LVALUE_ID_IDX ON PROFILE_AO_FIELD_VALUE
(NLS_LOWER(VALUE,''NLS_SORT = XTurkish''), ID)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
     
  
drop procedure del_indx;

drop procedure create_indx;

