declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00904); -- invalid identifier

begin
  stat := '
  ALTER TABLE IB_RE_GROUPS
    DROP COLUMN DISPLAY_NAME_LOWER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
 
declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- name is already used by an existing object

begin
  stat := '
   ALTER TABLE IB_RE_GROUPS 
	ADD DISPLAY_NAME_LOWER VARCHAR2(1024 char)  
	GENERATED ALWAYS AS (NLS_LOWER(DISPLAY_NAME,''NLS_SORT = XTurkish'')) VIRTUAL
  ';

  execute immediate (stat);

exception
  when exception1 then null;
  WHEN others THEN 
  stat := '
	ALTER TABLE IB_RE_GROUPS 
	ADD (DISPLAY_NAME_LOWER VARCHAR2(4000 char) 
	GENERATED ALWAYS AS (NLS_LOWER(DISPLAY_NAME,''NLS_SORT = XTurkish'')) VIRTUAL)
  ';
  execute immediate (stat);
 
 stat := '
	ALTER TABLE IB_RE_GROUPS 
	MODIFY(
		DISPLAY_NAME_LOWER VARCHAR2 (1024 CHAR)
	)
  ';
  execute immediate (stat);

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00904); -- invalid identifier

begin
  stat := '
  ALTER TABLE IB_RE_USERS
    DROP COLUMN USER_NAME_LOWER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
 
declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- name is already used by an existing object

begin
  stat := '
   ALTER TABLE IB_RE_USERS 
	ADD USER_NAME_LOWER VARCHAR2(256 char)  
	GENERATED ALWAYS AS (NLS_LOWER(USER_NAME,''NLS_SORT = XTurkish'')) VIRTUAL
  ';

  execute immediate (stat);

exception
  when exception1 then null;
  WHEN others THEN 
  stat := '
	ALTER TABLE IB_RE_USERS 
	ADD USER_NAME_LOWER VARCHAR2(1024 char)  
	GENERATED ALWAYS AS (NLS_LOWER(USER_NAME,''NLS_SORT = XTurkish'')) VIRTUAL
  ';
  execute immediate (stat);
 
 stat := '
	ALTER TABLE IB_RE_USERS 
	MODIFY(
		USER_NAME_LOWER VARCHAR2 (256 CHAR)
	)
  ';
  execute immediate (stat);

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX GROUP_TAR_DISP_NAME_LOWER_IDX ON IB_RE_GROUPS 
  (TARGET_ID, DISPLAY_NAME_LOWER)
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX IB_X_RE_USERS_USER_NAME ON IB_RE_USERS 
  (TARGET_ID, USER_NAME_LOWER)
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/