create or replace procedure del_indx(index_name in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-1418); -- index does not exist
begin
    execute immediate 'DROP INDEX ' || index_name;
exception
    when others then null;
end del_indx;
/

create or replace procedure create_indx(stat in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object
begin
    execute immediate (stat);
exception
    when exception1 then null;
end create_indx;
/

CALL del_indx('CUSTOM_FILTER_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX CUSTOM_FILTER_LNAME_IDX ON CUSTOM_FILTER
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');


CALL del_indx('LANGUAGE_LNAME_LCOU_IDX');

CALL create_indx('
CREATE UNIQUE INDEX LANGUAGE_LNAME_LCOU_IDX ON LANGUAGE
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''), NLS_LOWER(COUNTRY,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  

CALL del_indx('LOCALIZATION_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX LOCALIZATION_LNAME_IDX ON LOCALIZATION
(NLS_LOWER(CODE,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');  

  
CALL del_indx('REPORT_LNAME_DASHBOARD_IDX');

CALL create_indx('
CREATE UNIQUE INDEX REPORT_LNAME_DASHBOARD_IDX ON REPORT
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''), DASHBOARD)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  
  
CALL del_indx('REP_FIL_REPORT_FILTER_IDX');

CALL create_indx('
CREATE UNIQUE INDEX REP_FIL_REPORT_FILTER_IDX ON REPORT_FILTER
(REPORT, NLS_LOWER(FILTER,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  
  
CALL del_indx('REPORT_TYPE_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX REPORT_TYPE_LNAME_IDX ON REPORT_TYPE
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');  
   
  
CALL del_indx('R_QUERY_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX R_QUERY_LNAME_IDX ON R_QUERY
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');  
 
  
drop procedure del_indx;

drop procedure create_indx;

