create or replace procedure del_indx(index_name in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-1418); -- index does not exist
begin
    execute immediate 'DROP INDEX ' || index_name;
exception
    when others then null;
end del_indx;
/

create or replace procedure create_indx(stat in varchar2) as
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object
begin
    execute immediate (stat);
exception
    when exception1 then null;
end create_indx;
/


CALL del_indx('CLASS_NAME_REALM_NAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX CLASS_NAME_REALM_NAME_IDX ON CLASS_NAME
(REALM, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
 

CALL del_indx('CONF_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX CONF_LNAME_IDX ON CONFIGURATION
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
  

CALL del_indx('FAMILY_REALM_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX FAMILY_REALM_LNAME_IDX ON FAMILY
(REALM, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
   

CALL del_indx('SCHED_PROP_SCHED_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX SCHED_PROP_SCHED_LNAME_IDX ON SCHEDULER_PROP
(SCHEDULER, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
    

CALL del_indx('TIMER_REALM_NAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX TIMER_REALM_NAME_IDX ON TIMER
(REALM, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
      

CALL del_indx('TW_PROP_REALM_TW_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX TW_PROP_REALM_TW_LNAME_IDX ON TIMER_WORK_PROP
(REALM, TIMER_WORK, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');
       

CALL del_indx('WORK_REALM_NAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX WORK_REALM_NAME_IDX ON WORK
(REALM, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');   
         

CALL del_indx('WORK_PROP_REALM_WORK_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX WORK_PROP_REALM_WORK_LNAME_IDX ON WORK_PROP
(REALM, WORK, NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');   
  
         
CALL del_indx('CFG_APPLICATION_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX CFG_APPLICATION_LNAME_IDX ON CFG_APPLICATION
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''), TYPE)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');   
    
         
CALL del_indx('REALM_LNAME_IDX');

CALL create_indx('
CREATE UNIQUE INDEX REALM_LNAME_IDX ON REALM
(NLS_LOWER(NAME,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');   
    
         
CALL del_indx('AUDIT_EVENT_LANG_IDX');

CALL create_indx('
CREATE UNIQUE INDEX AUDIT_EVENT_LANG_IDX ON AUDIT_EVENT
(EVENT_ID, NLS_LOWER(LANGUAGE,''NLS_SORT = XTurkish''))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ');   
  
  
  
drop procedure del_indx;

drop procedure create_indx;

